'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _get = require('babel-runtime/helpers/get')['default'];

var _bind = require('babel-runtime/helpers/bind')['default'];

var _toConsumableArray = require('babel-runtime/helpers/to-consumable-array')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _util = require('./util');

var util = _interopRequireWildcard(_util);

var _errors = require('./errors');

var err = _interopRequireWildcard(_errors);

var _protoDef = require('./proto-def');

var _protoDef2 = _interopRequireDefault(_protoDef);

var _base = require('./base');

var _symbols = require('./symbols');

var protoTermType = _protoDef2['default'].Term.TermType;
var ar = util.ar;
var varar = util.varar;
var aropt = util.aropt;

var rdb = function rdb() {
  return rdb.expr.apply(rdb, arguments);
};

/* istanbul ignore next */
function funcWrap(val) {
  if (val === void 0) {
    return val;
  }
  val = rdb.expr(val);

  var ivarScan = function ivarScan(node) {
    if (!(node instanceof TermBase)) {
      return false;
    }
    if (node instanceof ImplicitVar) {
      return true;
    }
    if (node.args.map(ivarScan).some(function (a) {
      return a;
    })) {
      return true;
    }

    var res = [];
    for (var k in node.optargs) {
      if (!node.optargs.hasOwnProperty(k)) {
        continue;
      }
      res.push(node.optargs[k]);
    }
    if (res.some(function (a) {
      return ivarScan(a);
    })) {
      return true;
    }

    return false;
  };
  if (ivarScan(val)) {
    return new Func({}, function (x) {
      return val;
    });
  }
  return val;
}

function hasImplicit(args) {
  //args is an array of (string and arrays)
  //We recurse to look for 'r.row' which is an implicit var
  if (Array.isArray(args)) {
    for (var arg in args) {
      if (hasImplicit(arg)) {
        return true;
      }
    }
  } else if (args === 'r.row') {
    return true;
  }
  return false;
}

var TermBase = (function () {
  function TermBase() {
    _classCallCheck(this, TermBase);

    var self = ar(function (field) {
      return self.bracket(field);
    });
    self.__proto__ = this.__proto__;
    return self;
  }

  _createClass(TermBase, [{
    key: 'run',
    value: function run() {
      var query;
      return _regeneratorRuntime.async(function run$(context$2$0) {
        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            query = this.build();
            context$2$0.next = 3;
            return _regeneratorRuntime.awrap(this[_symbols.SymClient].query(query));

          case 3:
            return context$2$0.abrupt('return', context$2$0.sent);

          case 4:
          case 'end':
            return context$2$0.stop();
        }
      }, null, this);
    }
  }, {
    key: 'toString',
    value: function toString() {
      return err.printQuery(this);
    }
  }]);

  return TermBase;
})();

TermBase.prototype.showRunWarning = true;

var RDBVal = (function (_TermBase) {
  function RDBVal() {
    _classCallCheck(this, RDBVal);

    var self = _get(Object.getPrototypeOf(RDBVal.prototype), 'constructor', this).call(this);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(RDBVal, _TermBase);

  _createClass(RDBVal, [{
    key: 'eq',
    value: function eq() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var res = new (_bind.apply(Eq, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'ne',
    value: function ne() {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      var res = new (_bind.apply(Ne, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'lt',
    value: function lt() {
      for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      var res = new (_bind.apply(Lt, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'le',
    value: function le() {
      for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }

      var res = new (_bind.apply(Le, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'gt',
    value: function gt() {
      for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
        args[_key5] = arguments[_key5];
      }

      var res = new (_bind.apply(Gt, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'ge',
    value: function ge() {
      for (var _len6 = arguments.length, args = Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
        args[_key6] = arguments[_key6];
      }

      var res = new (_bind.apply(Ge, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'not',
    value: function not() {
      for (var _len7 = arguments.length, args = Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
        args[_key7] = arguments[_key7];
      }

      var res = new (_bind.apply(Not, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'add',
    value: function add() {
      for (var _len8 = arguments.length, args = Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {
        args[_key8] = arguments[_key8];
      }

      var res = new (_bind.apply(Add, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'sub',
    value: function sub() {
      for (var _len9 = arguments.length, args = Array(_len9), _key9 = 0; _key9 < _len9; _key9++) {
        args[_key9] = arguments[_key9];
      }

      var res = new (_bind.apply(Sub, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'mul',
    value: function mul() {
      for (var _len10 = arguments.length, args = Array(_len10), _key10 = 0; _key10 < _len10; _key10++) {
        args[_key10] = arguments[_key10];
      }

      var res = new (_bind.apply(Mul, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'div',
    value: function div() {
      for (var _len11 = arguments.length, args = Array(_len11), _key11 = 0; _key11 < _len11; _key11++) {
        args[_key11] = arguments[_key11];
      }

      var res = new (_bind.apply(Div, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'mod',
    value: function mod() {
      for (var _len12 = arguments.length, args = Array(_len12), _key12 = 0; _key12 < _len12; _key12++) {
        args[_key12] = arguments[_key12];
      }

      var res = new (_bind.apply(Mod, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'append',

    //floor(...args) { return new Floor ( {}, this, ...args ); }
    //ceil(...args) { return new Ceil ( {}, this, ...args ); }
    //round(...args) { return new Round ( {}, this, ...args ); }

    value: function append() {
      for (var _len13 = arguments.length, args = Array(_len13), _key13 = 0; _key13 < _len13; _key13++) {
        args[_key13] = arguments[_key13];
      }

      var res = new (_bind.apply(Append, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'prepend',
    value: function prepend() {
      for (var _len14 = arguments.length, args = Array(_len14), _key14 = 0; _key14 < _len14; _key14++) {
        args[_key14] = arguments[_key14];
      }

      var res = new (_bind.apply(Prepend, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'difference',
    value: function difference() {
      for (var _len15 = arguments.length, args = Array(_len15), _key15 = 0; _key15 < _len15; _key15++) {
        args[_key15] = arguments[_key15];
      }

      var res = new (_bind.apply(Difference, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'setInsert',
    value: function setInsert() {
      for (var _len16 = arguments.length, args = Array(_len16), _key16 = 0; _key16 < _len16; _key16++) {
        args[_key16] = arguments[_key16];
      }

      var res = new (_bind.apply(SetInsert, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'setUnion',
    value: function setUnion() {
      for (var _len17 = arguments.length, args = Array(_len17), _key17 = 0; _key17 < _len17; _key17++) {
        args[_key17] = arguments[_key17];
      }

      var res = new (_bind.apply(SetUnion, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'setIntersection',
    value: function setIntersection() {
      for (var _len18 = arguments.length, args = Array(_len18), _key18 = 0; _key18 < _len18; _key18++) {
        args[_key18] = arguments[_key18];
      }

      var res = new (_bind.apply(SetIntersection, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'setDifference',
    value: function setDifference() {
      for (var _len19 = arguments.length, args = Array(_len19), _key19 = 0; _key19 < _len19; _key19++) {
        args[_key19] = arguments[_key19];
      }

      var res = new (_bind.apply(SetDifference, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'skip',
    value: function skip() {
      for (var _len20 = arguments.length, args = Array(_len20), _key20 = 0; _key20 < _len20; _key20++) {
        args[_key20] = arguments[_key20];
      }

      var res = new (_bind.apply(Skip, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'limit',
    value: function limit() {
      for (var _len21 = arguments.length, args = Array(_len21), _key21 = 0; _key21 < _len21; _key21++) {
        args[_key21] = arguments[_key21];
      }

      var res = new (_bind.apply(Limit, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'getField',
    value: function getField() {
      for (var _len22 = arguments.length, args = Array(_len22), _key22 = 0; _key22 < _len22; _key22++) {
        args[_key22] = arguments[_key22];
      }

      var res = new (_bind.apply(GetField, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'insertAt',
    value: function insertAt() {
      for (var _len23 = arguments.length, args = Array(_len23), _key23 = 0; _key23 < _len23; _key23++) {
        args[_key23] = arguments[_key23];
      }

      var res = new (_bind.apply(InsertAt, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'spliceAt',
    value: function spliceAt() {
      for (var _len24 = arguments.length, args = Array(_len24), _key24 = 0; _key24 < _len24; _key24++) {
        args[_key24] = arguments[_key24];
      }

      var res = new (_bind.apply(SpliceAt, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'deleteAt',
    value: function deleteAt() {
      for (var _len25 = arguments.length, args = Array(_len25), _key25 = 0; _key25 < _len25; _key25++) {
        args[_key25] = arguments[_key25];
      }

      var res = new (_bind.apply(DeleteAt, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'changeAt',
    value: function changeAt() {
      for (var _len26 = arguments.length, args = Array(_len26), _key26 = 0; _key26 < _len26; _key26++) {
        args[_key26] = arguments[_key26];
      }

      var res = new (_bind.apply(ChangeAt, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'hasFields',
    value: function hasFields() {
      for (var _len27 = arguments.length, args = Array(_len27), _key27 = 0; _key27 < _len27; _key27++) {
        args[_key27] = arguments[_key27];
      }

      var res = new (_bind.apply(HasFields, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'withFields',
    value: function withFields() {
      for (var _len28 = arguments.length, args = Array(_len28), _key28 = 0; _key28 < _len28; _key28++) {
        args[_key28] = arguments[_key28];
      }

      var res = new (_bind.apply(WithFields, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'keys',
    value: function keys() {
      for (var _len29 = arguments.length, args = Array(_len29), _key29 = 0; _key29 < _len29; _key29++) {
        args[_key29] = arguments[_key29];
      }

      var res = new (_bind.apply(Keys, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'contains',
    value: function contains() {
      for (var _len30 = arguments.length, args = Array(_len30), _key30 = 0; _key30 < _len30; _key30++) {
        args[_key30] = arguments[_key30];
      }

      var res = new (_bind.apply(Contains, [null].concat([{}, this], _toConsumableArray(args.map(funcWrap)))))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'offsetsOf',
    value: function offsetsOf() {
      for (var _len31 = arguments.length, args = Array(_len31), _key31 = 0; _key31 < _len31; _key31++) {
        args[_key31] = arguments[_key31];
      }

      var res = new (_bind.apply(OffsetsOf, [null].concat([{}, this], _toConsumableArray(args.map(funcWrap)))))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'pluck',
    value: function pluck() {
      for (var _len32 = arguments.length, args = Array(_len32), _key32 = 0; _key32 < _len32; _key32++) {
        args[_key32] = arguments[_key32];
      }

      var res = new (_bind.apply(Pluck, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'without',
    value: function without() {
      for (var _len33 = arguments.length, args = Array(_len33), _key33 = 0; _key33 < _len33; _key33++) {
        args[_key33] = arguments[_key33];
      }

      var res = new (_bind.apply(Without, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'merge',
    value: function merge() {
      for (var _len34 = arguments.length, args = Array(_len34), _key34 = 0; _key34 < _len34; _key34++) {
        args[_key34] = arguments[_key34];
      }

      var res = new (_bind.apply(Merge, [null].concat([{}, this], _toConsumableArray(args.map(funcWrap)))))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'reduce',
    value: function reduce() {
      for (var _len35 = arguments.length, args = Array(_len35), _key35 = 0; _key35 < _len35; _key35++) {
        args[_key35] = arguments[_key35];
      }

      var res = new (_bind.apply(Reduce, [null].concat([{}, this], _toConsumableArray(args.map(funcWrap)))))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'concatMap',
    value: function concatMap() {
      for (var _len36 = arguments.length, args = Array(_len36), _key36 = 0; _key36 < _len36; _key36++) {
        args[_key36] = arguments[_key36];
      }

      var res = new (_bind.apply(ConcatMap, [null].concat([{}, this], _toConsumableArray(args.map(funcWrap)))))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'count',
    value: function count() {
      for (var _len37 = arguments.length, args = Array(_len37), _key37 = 0; _key37 < _len37; _key37++) {
        args[_key37] = arguments[_key37];
      }

      var res = new (_bind.apply(Count, [null].concat([{}, this], _toConsumableArray(args.map(funcWrap)))))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'forEach',
    value: function forEach() {
      for (var _len38 = arguments.length, args = Array(_len38), _key38 = 0; _key38 < _len38; _key38++) {
        args[_key38] = arguments[_key38];
      }

      var res = new (_bind.apply(ForEach, [null].concat([{}, this], _toConsumableArray(args.map(funcWrap)))))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'sum',
    value: function sum() {
      for (var _len39 = arguments.length, args = Array(_len39), _key39 = 0; _key39 < _len39; _key39++) {
        args[_key39] = arguments[_key39];
      }

      var res = new (_bind.apply(Sum, [null].concat([{}, this], _toConsumableArray(args.map(funcWrap)))))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'avg',
    value: function avg() {
      for (var _len40 = arguments.length, args = Array(_len40), _key40 = 0; _key40 < _len40; _key40++) {
        args[_key40] = arguments[_key40];
      }

      var res = new (_bind.apply(Avg, [null].concat([{}, this], _toConsumableArray(args.map(funcWrap)))))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'split',
    value: function split() {
      for (var _len41 = arguments.length, args = Array(_len41), _key41 = 0; _key41 < _len41; _key41++) {
        args[_key41] = arguments[_key41];
      }

      var res = new (_bind.apply(Split, [null].concat([{}, this], _toConsumableArray(args.map(funcWrap)))))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'union',
    value: function union() {
      for (var _len42 = arguments.length, args = Array(_len42), _key42 = 0; _key42 < _len42; _key42++) {
        args[_key42] = arguments[_key42];
      }

      var res = new (_bind.apply(Union, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'nth',
    value: function nth() {
      for (var _len43 = arguments.length, args = Array(_len43), _key43 = 0; _key43 < _len43; _key43++) {
        args[_key43] = arguments[_key43];
      }

      var res = new (_bind.apply(Nth, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'bracket',
    value: function bracket() {
      for (var _len44 = arguments.length, args = Array(_len44), _key44 = 0; _key44 < _len44; _key44++) {
        args[_key44] = arguments[_key44];
      }

      var res = new (_bind.apply(Bracket, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'toJSON',
    value: function toJSON() {
      for (var _len45 = arguments.length, args = Array(_len45), _key45 = 0; _key45 < _len45; _key45++) {
        args[_key45] = arguments[_key45];
      }

      var res = new (_bind.apply(ToJsonString, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'toJsonString',
    value: function toJsonString() {
      for (var _len46 = arguments.length, args = Array(_len46), _key46 = 0; _key46 < _len46; _key46++) {
        args[_key46] = arguments[_key46];
      }

      var res = new (_bind.apply(ToJsonString, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'match',
    value: function match() {
      for (var _len47 = arguments.length, args = Array(_len47), _key47 = 0; _key47 < _len47; _key47++) {
        args[_key47] = arguments[_key47];
      }

      var res = new (_bind.apply(Match, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'upcase',
    value: function upcase() {
      for (var _len48 = arguments.length, args = Array(_len48), _key48 = 0; _key48 < _len48; _key48++) {
        args[_key48] = arguments[_key48];
      }

      var res = new (_bind.apply(Upcase, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'downcase',
    value: function downcase() {
      for (var _len49 = arguments.length, args = Array(_len49), _key49 = 0; _key49 < _len49; _key49++) {
        args[_key49] = arguments[_key49];
      }

      var res = new (_bind.apply(Downcase, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'isEmpty',
    value: function isEmpty() {
      for (var _len50 = arguments.length, args = Array(_len50), _key50 = 0; _key50 < _len50; _key50++) {
        args[_key50] = arguments[_key50];
      }

      var res = new (_bind.apply(IsEmpty, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'innerJoin',
    value: function innerJoin() {
      for (var _len51 = arguments.length, args = Array(_len51), _key51 = 0; _key51 < _len51; _key51++) {
        args[_key51] = arguments[_key51];
      }

      var res = new (_bind.apply(InnerJoin, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'outerJoin',
    value: function outerJoin() {
      for (var _len52 = arguments.length, args = Array(_len52), _key52 = 0; _key52 < _len52; _key52++) {
        args[_key52] = arguments[_key52];
      }

      var res = new (_bind.apply(OuterJoin, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'zip',
    value: function zip() {
      for (var _len53 = arguments.length, args = Array(_len53), _key53 = 0; _key53 < _len53; _key53++) {
        args[_key53] = arguments[_key53];
      }

      var res = new (_bind.apply(Zip, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'coerceTo',
    value: function coerceTo() {
      for (var _len54 = arguments.length, args = Array(_len54), _key54 = 0; _key54 < _len54; _key54++) {
        args[_key54] = arguments[_key54];
      }

      var res = new (_bind.apply(CoerceTo, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'ungroup',
    value: function ungroup() {
      for (var _len55 = arguments.length, args = Array(_len55), _key55 = 0; _key55 < _len55; _key55++) {
        args[_key55] = arguments[_key55];
      }

      var res = new (_bind.apply(Ungroup, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'typeOf',
    value: function typeOf() {
      for (var _len56 = arguments.length, args = Array(_len56), _key56 = 0; _key56 < _len56; _key56++) {
        args[_key56] = arguments[_key56];
      }

      var res = new (_bind.apply(TypeOf, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'or',
    value: function or() {
      for (var _len57 = arguments.length, args = Array(_len57), _key57 = 0; _key57 < _len57; _key57++) {
        args[_key57] = arguments[_key57];
      }

      var res = new (_bind.apply(Or, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'and',
    value: function and() {
      for (var _len58 = arguments.length, args = Array(_len58), _key58 = 0; _key58 < _len58; _key58++) {
        args[_key58] = arguments[_key58];
      }

      var res = new (_bind.apply(And, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'toGeojson',
    value: function toGeojson() {
      for (var _len59 = arguments.length, args = Array(_len59), _key59 = 0; _key59 < _len59; _key59++) {
        args[_key59] = arguments[_key59];
      }

      var res = new (_bind.apply(ToGeojson, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'intersects',
    value: function intersects() {
      for (var _len60 = arguments.length, args = Array(_len60), _key60 = 0; _key60 < _len60; _key60++) {
        args[_key60] = arguments[_key60];
      }

      var res = new (_bind.apply(Intersects, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'includes',
    value: function includes() {
      for (var _len61 = arguments.length, args = Array(_len61), _key61 = 0; _key61 < _len61; _key61++) {
        args[_key61] = arguments[_key61];
      }

      var res = new (_bind.apply(Includes, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'fill',
    value: function fill() {
      for (var _len62 = arguments.length, args = Array(_len62), _key62 = 0; _key62 < _len62; _key62++) {
        args[_key62] = arguments[_key62];
      }

      var res = new (_bind.apply(Fill, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'polygonSub',
    value: function polygonSub() {
      for (var _len63 = arguments.length, args = Array(_len63), _key63 = 0; _key63 < _len63; _key63++) {
        args[_key63] = arguments[_key63];
      }

      var res = new (_bind.apply(PolygonSub, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'get',

    //tableDrop(...args) { let res = new TableDrop ( {}, this, ...args ); res[SymClient] = this[SymClient]; return res; }
    //tableList(...args) { let res = new TableList ( {}, this, ...args ); res[SymClient] = this[SymClient]; return res; }
    //config() { let res = new Config ( {}, this ); res[SymClient] = this[SymClient]; return res; }
    //status() { let res = new Status ( {}, this ); res[SymClient] = this[SymClient]; return res; }
    value: function get() {
      for (var _len64 = arguments.length, args = Array(_len64), _key64 = 0; _key64 < _len64; _key64++) {
        args[_key64] = arguments[_key64];
      }

      var res = new (_bind.apply(Get, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'sample',

    //indexDrop(...args) { let res = new IndexDrop ( {}, this, ...args ); res[SymClient] = this[SymClient]; return res; }
    //indexList(...args) { let res = new IndexList ( {}, this, ...args ); res[SymClient] = this[SymClient]; return res; }
    //indexStatus(...args) { let res = new IndexStatus ( {}, this, ...args ); res[SymClient] = this[SymClient]; return res; }
    //indexWait(...args) { let res = new IndexWait ( {}, this, ...args ); res[SymClient] = this[SymClient]; return res; }
    //info(...args) { let res = new Info ( {}, this, ...args ); res[SymClient] = this[SymClient]; return res; }
    value: function sample() {
      for (var _len65 = arguments.length, args = Array(_len65), _key65 = 0; _key65 < _len65; _key65++) {
        args[_key65] = arguments[_key65];
      }

      var res = new (_bind.apply(Sample, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'default',
    value: function _default() {
      for (var _len66 = arguments.length, args = Array(_len66), _key66 = 0; _key66 < _len66; _key66++) {
        args[_key66] = arguments[_key66];
      }

      var res = new (_bind.apply(Default, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'toISO8601',

    //rebalance() { let res = new Rebalance ( {}, this ); res[SymClient] = this[SymClient]; return res; }
    //sync(...args) { let res = new Sync ( {}, this, ...args ); res[SymClient] = this[SymClient]; return res; }
    value: function toISO8601() {
      for (var _len67 = arguments.length, args = Array(_len67), _key67 = 0; _key67 < _len67; _key67++) {
        args[_key67] = arguments[_key67];
      }

      var res = new (_bind.apply(ToISO8601, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'toEpochTime',
    value: function toEpochTime() {
      for (var _len68 = arguments.length, args = Array(_len68), _key68 = 0; _key68 < _len68; _key68++) {
        args[_key68] = arguments[_key68];
      }

      var res = new (_bind.apply(ToEpochTime, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'inTimezone',
    value: function inTimezone() {
      for (var _len69 = arguments.length, args = Array(_len69), _key69 = 0; _key69 < _len69; _key69++) {
        args[_key69] = arguments[_key69];
      }

      var res = new (_bind.apply(InTimezone, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'date',
    value: function date() {
      for (var _len70 = arguments.length, args = Array(_len70), _key70 = 0; _key70 < _len70; _key70++) {
        args[_key70] = arguments[_key70];
      }

      var res = new (_bind.apply(RQLDate, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'timeOfDay',
    value: function timeOfDay() {
      for (var _len71 = arguments.length, args = Array(_len71), _key71 = 0; _key71 < _len71; _key71++) {
        args[_key71] = arguments[_key71];
      }

      var res = new (_bind.apply(TimeOfDay, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'timezone',
    value: function timezone() {
      for (var _len72 = arguments.length, args = Array(_len72), _key72 = 0; _key72 < _len72; _key72++) {
        args[_key72] = arguments[_key72];
      }

      var res = new (_bind.apply(Timezone, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'year',
    value: function year() {
      for (var _len73 = arguments.length, args = Array(_len73), _key73 = 0; _key73 < _len73; _key73++) {
        args[_key73] = arguments[_key73];
      }

      var res = new (_bind.apply(Year, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'month',
    value: function month() {
      for (var _len74 = arguments.length, args = Array(_len74), _key74 = 0; _key74 < _len74; _key74++) {
        args[_key74] = arguments[_key74];
      }

      var res = new (_bind.apply(Month, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'day',
    value: function day() {
      for (var _len75 = arguments.length, args = Array(_len75), _key75 = 0; _key75 < _len75; _key75++) {
        args[_key75] = arguments[_key75];
      }

      var res = new (_bind.apply(Day, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'dayOfWeek',
    value: function dayOfWeek() {
      for (var _len76 = arguments.length, args = Array(_len76), _key76 = 0; _key76 < _len76; _key76++) {
        args[_key76] = arguments[_key76];
      }

      var res = new (_bind.apply(DayOfWeek, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'dayOfYear',
    value: function dayOfYear() {
      for (var _len77 = arguments.length, args = Array(_len77), _key77 = 0; _key77 < _len77; _key77++) {
        args[_key77] = arguments[_key77];
      }

      var res = new (_bind.apply(DayOfYear, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'hours',
    value: function hours() {
      for (var _len78 = arguments.length, args = Array(_len78), _key78 = 0; _key78 < _len78; _key78++) {
        args[_key78] = arguments[_key78];
      }

      var res = new (_bind.apply(Hours, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'minutes',
    value: function minutes() {
      for (var _len79 = arguments.length, args = Array(_len79), _key79 = 0; _key79 < _len79; _key79++) {
        args[_key79] = arguments[_key79];
      }

      var res = new (_bind.apply(Minutes, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'seconds',
    value: function seconds() {
      for (var _len80 = arguments.length, args = Array(_len80), _key80 = 0; _key80 < _len80; _key80++) {
        args[_key80] = arguments[_key80];
      }

      var res = new (_bind.apply(Seconds, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'uuid',
    value: function uuid() {
      for (var _len81 = arguments.length, args = Array(_len81), _key81 = 0; _key81 < _len81; _key81++) {
        args[_key81] = arguments[_key81];
      }

      var res = new (_bind.apply(UUID, [null].concat([{}, this], args)))();res[_symbols.SymClient] = this[_symbols.SymClient];return res;
    }
  }, {
    key: 'do',

    //reconfigure(opts) { let res = new Reconfigure(opts, this); res[SymClient] = this[SymClient]; return res; }

    value: function _do() {
      for (var _len82 = arguments.length, args = Array(_len82), _key82 = 0; _key82 < _len82; _key82++) {
        args[_key82] = arguments[_key82];
      }

      var res = new (_bind.apply(FunCall, [null].concat([{}, funcWrap(args.slice(-1)[0]), this], _toConsumableArray(args.slice(0, -1)))))();
      res[_symbols.SymClient] = this[_symbols.SymClient];
      return res;
    }
  }, {
    key: 'group',
    value: function group() {
      var opts = {};

      for (var _len83 = arguments.length, fieldsAndOpts = Array(_len83), _key83 = 0; _key83 < _len83; _key83++) {
        fieldsAndOpts[_key83] = arguments[_key83];
      }

      var fields = fieldsAndOpts;

      if (fieldsAndOpts.length > 0) {
        var perhapsOptDict = fieldsAndOpts[fieldsAndOpts.length - 1];
        if (perhapsOptDict && Object.prototype.toString.call(perhapsOptDict) === '[object Object]' && !(perhapsOptDict instanceof TermBase)) {
          opts = perhapsOptDict;
          fields = fieldsAndOpts.slice(0, fieldsAndOpts.length - 1);
        }
      }
      var res = new (_bind.apply(Group, [null].concat([opts, this], _toConsumableArray(fields.map(funcWrap)))))();
      res[_symbols.SymClient] = this[_symbols.SymClient];
      return res;
    }
  }, {
    key: 'orderBy',
    value: function orderBy() {
      var opts = {};

      for (var _len84 = arguments.length, attrsAndOpts = Array(_len84), _key84 = 0; _key84 < _len84; _key84++) {
        attrsAndOpts[_key84] = arguments[_key84];
      }

      var attrs = attrsAndOpts;

      var perhapsOptDict = attrsAndOpts[attrsAndOpts.length - 1];
      if (perhapsOptDict && Object.prototype.toString.call(perhapsOptDict) === '[object Object]' && !(perhapsOptDict instanceof TermBase)) {
        opts = perhapsOptDict;
        attrs = attrsAndOpts.slice(0, attrsAndOpts.length - 1);
      }
      attrs = attrs.map(function (attr) {
        if (attr instanceof Asc || attr instanceof Desc) {
          return attr;
        } else {
          return funcWrap(attr);
        }
      });
      var res = new (_bind.apply(OrderBy, [null].concat([opts, this], _toConsumableArray(attrs))))();
      res[_symbols.SymClient] = this[_symbols.SymClient];
      return res;
    }
  }, {
    key: 'getAll',
    value: function getAll() {
      var opts = {};

      for (var _len85 = arguments.length, keysAndOpts = Array(_len85), _key85 = 0; _key85 < _len85; _key85++) {
        keysAndOpts[_key85] = arguments[_key85];
      }

      var keys = keysAndOpts;
      if (keysAndOpts.length > 1) {
        var perhapsOptDict = keysAndOpts[keysAndOpts.length - 1];
        if (perhapsOptDict && Object.prototype.toString.call(perhapsOptDict) === '[object Object]' && !(perhapsOptDict instanceof TermBase)) {
          opts = perhapsOptDict;
          keys = keysAndOpts.slice(0, keysAndOpts.length - 1);
        }
      }
      var res = new (_bind.apply(GetAll, [null].concat([opts, this], _toConsumableArray(keys))))();
      res[_symbols.SymClient] = this[_symbols.SymClient];
      return res;
    }
  }, {
    key: 'min',
    value: function min() {
      var opts = {};

      for (var _len86 = arguments.length, keysAndOpts = Array(_len86), _key86 = 0; _key86 < _len86; _key86++) {
        keysAndOpts[_key86] = arguments[_key86];
      }

      var keys = keysAndOpts;
      if (keysAndOpts.length === 1) {
        var perhapsOptDict = keysAndOpts[keysAndOpts.length - 1];
        if (perhapsOptDict && Object.prototype.toString.call(perhapsOptDict) === '[object Object]' && !(perhapsOptDict instanceof TermBase)) {
          opts = perhapsOptDict;
          keys = keysAndOpts.slice(0, keysAndOpts.length - 1);
        }
      }
      var res = new (_bind.apply(Min, [null].concat([opts, this], _toConsumableArray(keys.map(funcWrap)))))();
      res[_symbols.SymClient] = this[_symbols.SymClient];
      return res;
    }
  }, {
    key: 'max',
    value: function max() {
      var opts = {};

      for (var _len87 = arguments.length, keysAndOpts = Array(_len87), _key87 = 0; _key87 < _len87; _key87++) {
        keysAndOpts[_key87] = arguments[_key87];
      }

      var keys = keysAndOpts;
      if (keysAndOpts.length === 1) {
        var perhapsOptDict = keysAndOpts[keysAndOpts.length - 1];
        if (perhapsOptDict && Object.prototype.toString.call(perhapsOptDict) === '[object Object]' && !(perhapsOptDict instanceof TermBase)) {
          opts = perhapsOptDict;
          keys = keysAndOpts.slice(0, keysAndOpts.length - 1);
        }
      }
      var res = new (_bind.apply(Max, [null].concat([opts, this], _toConsumableArray(keys.map(funcWrap)))))();
      res[_symbols.SymClient] = this[_symbols.SymClient];
      return res;
    }
  }]);

  return RDBVal;
})(TermBase);

//RDBVal.prototype.changes =  aropt(function (opts) {
//  let res = urn new Changes(opts, this);
//  res[SymClient] = this[SymClient];
//  return res;
//});
RDBVal.prototype.slice = varar(1, 3, function (left, right_or_opts, opts) {
  if ((0, _base.exists)(opts)) {
    var res = new Slice(opts, this, left, right_or_opts);
    res[_symbols.SymClient] = this[_symbols.SymClient];
    return res;
  } else if (typeof right_or_opts !== 'undefined') {
    if (Object.prototype.toString.call(right_or_opts) === '[object Object]' && !(right_or_opts instanceof TermBase)) {
      var res = new Slice(right_or_opts, this, left);
      res[_symbols.SymClient] = this[_symbols.SymClient];
      return res;
    } else {
      var res = new Slice({}, this, left, right_or_opts);
      res[_symbols.SymClient] = this[_symbols.SymClient];
      return res;
    }
  } else {
    var res = new Slice({}, this, left);
    res[_symbols.SymClient] = this[_symbols.SymClient];
    return res;
  }
});
RDBVal.prototype.between = aropt(function (left, right, opts) {
  var res = new Between(opts, this, left, right);
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

RDBVal.prototype.distinct = aropt(function (opts) {
  var res = new Distinct(opts, this);
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

RDBVal.prototype.map = varar(1, null, function () {
  for (var _len88 = arguments.length, args = Array(_len88), _key88 = 0; _key88 < _len88; _key88++) {
    args[_key88] = arguments[_key88];
  }

  var funcArg = args.pop();
  var res = new (_bind.apply(Map, [null].concat([{}, this], args, [funcWrap(funcArg)])))();
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

RDBVal.prototype.filter = aropt(function (predicate, opts) {
  var res = new Filter(opts, this, funcWrap(predicate));
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

RDBVal.prototype.eqJoin = aropt(function (left_attr, right, opts) {
  var res = new EqJoin(opts, this, funcWrap(left_attr), right);
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

RDBVal.prototype.update = aropt(function (func, opts) {
  var res = new Update(opts, this, funcWrap(func));
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

RDBVal.prototype['delete'] = aropt(function (opts) {
  var res = new Delete(opts, this);
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

RDBVal.prototype.replace = aropt(function (func, opts) {
  var res = new Replace(opts, this, funcWrap(func));
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

RDBVal.prototype.distance = aropt(function (g, opts) {
  var res = new Distance(opts, this, g);
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

//RDBVal.prototype.tableCreate = aropt(function (tblName, opts) {
//  return new TableCreate(opts, this, tblName);
//});

//RDBVal.prototype.wait = aropt(function (opts) {
//  return new Wait(opts, this);
//});

RDBVal.prototype.table = aropt(function (tblName, opts) {
  var res = new Table(opts, this, tblName);
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

RDBVal.prototype.insert = aropt(function (doc, opts) {
  var res = new Insert(opts, this, rdb.expr(doc));
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

//RDBVal.prototype.IndexCreate = varar(1, 3, function (name ,defun_or_opts, opts) {
//  if(exists(opts)) {
//    return new IndexCreate(opts, this, name, funcWrap(defun_or_opts));
//  } else if(exists(defun_or_opts)) {
//    if(Object.prototype.toString.call(defun_or_opts) === '[object Object]' &&
//       typeof defun_or_opts !== 'function' &&
//         !(defun_or_opts instanceof TermBase)) {
//      return new IndexCreate(defun_or_opts, this, name);
//    } else {
//      return new IndexCreate({}, this, name, funcWrap(defun_or_opts));
//    }
//  } else {
//    new IndexCreate({}, this, name);
//  }
//});

//RDBVal.prototype.IndexRename = aropt(function (old_name, new_name, opts) {
//  return new IndexRename(opts, this, old_name, new_name);
//});

RDBVal.prototype.during = aropt(function (t2, t3, opts) {
  var res = new During(opts, this, t2, t3);
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

RDBVal.prototype.getIntersecting = aropt(function (g, opts) {
  var res = new GetIntersecting(opts, this, g);
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

RDBVal.prototype.getNearest = aropt(function (g, opts) {
  var res = new GetNearest(opts, this, g);
  res[_symbols.SymClient] = this[_symbols.SymClient];
  return res;
});

var DatumTerm = (function (_RDBVal) {
  function DatumTerm(val) {
    _classCallCheck(this, DatumTerm);

    var self = _get(Object.getPrototypeOf(DatumTerm.prototype), 'constructor', this).call(this);
    self.__proto__ = this.__proto__;
    self.data = val;
    return self;
  }

  _inherits(DatumTerm, _RDBVal);

  _createClass(DatumTerm, [{
    key: 'compose',
    value: function compose() {
      switch (typeof this.data) {
        case 'string':
          return '"' + this.data + '"';
        default:
          return '' + this.data;
      }
    }
  }, {
    key: 'build',
    value: function build() {
      if (typeof this.data === 'number') {
        if (!isFinite(this.data)) {
          throw new TypeError('Illegal non-finite number `' + this.data.toString() + '`.');
        }
      }
      return this.data;
    }
  }]);

  return DatumTerm;
})(RDBVal);

DatumTerm.prototype.args = [];
DatumTerm.prototype.optargs = {};

function translateBackOptargs(optargs) {
  var result = {};
  for (var key in optargs) {
    if (!optargs.hasOwnProperty(key)) {
      continue;
    }
    result[util.toCamelCase(key)] = optargs[key];
  }
  return result;
}

function translateOptargs(optargs) {
  var result = {};
  for (var key in optargs) {
    /* istanbul ignore if */
    if (key === void 0 || optargs[key] === void 0 && !optargs.hasOwnProperty(key)) {
      continue;
    }
    result[util.fromCamelCase(key)] = rdb.expr(optargs[key]);
  }
  return result;
}

var RDBOp = (function (_RDBVal2) {
  function RDBOp(optargs) {
    var _this = this;

    _classCallCheck(this, RDBOp);

    var self = _get(Object.getPrototypeOf(RDBOp.prototype), 'constructor', this).call(this);
    self.__proto__ = this.__proto__;

    for (var _len89 = arguments.length, args = Array(_len89 > 1 ? _len89 - 1 : 0), _key89 = 1; _key89 < _len89; _key89++) {
      args[_key89 - 1] = arguments[_key89];
    }

    self.args = args.map(function (arg, i) {
      /* istanbul ignore else */
      if (arg !== void 0) {
        return rdb.expr(arg);
      } else {
        throw new err.RqlDriverError('Argument ' + i + ' to ' + (_this.st || _this.mt) + ' may not be `undefined`.');
      }
    });
    self.optargs = translateOptargs(optargs);
    return self;
  }

  _inherits(RDBOp, _RDBVal2);

  _createClass(RDBOp, [{
    key: 'build',
    value: function build() {
      //console.log(this.tt, this.constructor.name);

      var res = [this.tt, []];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = _getIterator(this.args), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var arg = _step.value;

          res[1].push(arg.build());
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator['return']) {
            _iterator['return']();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var opts = {};
      var add_opts = false;

      for (var key in this.optargs) {
        /* istanbul ignore if */
        if (!this.optargs.hasOwnProperty(key)) {
          continue;
        }
        add_opts = true;
        opts[key] = this.optargs[key].build();
      }
      if (add_opts) {
        res.push(opts);
      }
      return res;
    }
  }, {
    key: 'compose',
    value: function compose(args, optargs) {
      if (this.st) {
        return ['r.', this.st, '(', intspallargs(args, optargs), ')'];
      } else {
        if (shouldWrap(this.args[0])) {
          args[0] = ['r(', args[0], ')'];
        }
        return [args[0], '.', this.mt, '(', intspallargs(args.slice(1), optargs), ')'];
      }
    }
  }]);

  return RDBOp;
})(RDBVal);

var RDBConstant = (function (_RDBOp) {
  function RDBConstant() {
    _classCallCheck(this, RDBConstant);

    var self = _get(Object.getPrototypeOf(RDBConstant.prototype), 'constructor', this).call(this);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(RDBConstant, _RDBOp);

  _createClass(RDBConstant, [{
    key: 'compose',
    value: function compose(args, optargs) {
      return ['r.', this.st];
    }
  }]);

  return RDBConstant;
})(RDBOp);

function intsp(seq) {
  if (seq[0] == null) {
    return [];
  }
  var res = [seq[0]];
  seq.slice(1).forEach(function (e) {
    res.push(', ', e);
  });
  return res;
}

function kved(optargs) {
  return ['{', intsp((function () {
    var res = [];
    for (var k in optargs) {
      if (!optargs.hasOwnProperty(k)) {
        continue;
      }
      res.push([k, ': ', optargs[k]]);
    }
    return res;
  })()), '}'];
}

function intspallargs(args, optargs) {
  var argrepr = [];
  if (args.length > 0) {
    argrepr.push(intsp(args));
  }
  if (_Object$keys(optargs).length > 0) {
    if (argrepr.length > 0) {
      argrepr.push(', ');
    }
    argrepr.push(kved(translateBackOptargs(optargs)));
  }
  return argrepr;
}

function shouldWrap(arg) {
  return arg instanceof DatumTerm || arg instanceof MakeArray || arg instanceof MakeObject;
}

var Contains = (function (_RDBOp2) {
  function Contains() {
    _classCallCheck(this, Contains);

    for (var _len90 = arguments.length, args = Array(_len90), _key90 = 0; _key90 < _len90; _key90++) {
      args[_key90] = arguments[_key90];
    }

    var self = _get(Object.getPrototypeOf(Contains.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Contains, _RDBOp2);

  return Contains;
})(RDBOp);

Contains.prototype.tt = protoTermType.CONTAINS;
Contains.prototype.mt = 'contains';

var InsertAt = (function (_RDBOp3) {
  function InsertAt() {
    _classCallCheck(this, InsertAt);

    for (var _len91 = arguments.length, args = Array(_len91), _key91 = 0; _key91 < _len91; _key91++) {
      args[_key91] = arguments[_key91];
    }

    var self = _get(Object.getPrototypeOf(InsertAt.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(InsertAt, _RDBOp3);

  return InsertAt;
})(RDBOp);

InsertAt.prototype.tt = protoTermType.INSERT_AT;
InsertAt.prototype.mt = 'insertAt';

var SpliceAt = (function (_RDBOp4) {
  function SpliceAt() {
    _classCallCheck(this, SpliceAt);

    for (var _len92 = arguments.length, args = Array(_len92), _key92 = 0; _key92 < _len92; _key92++) {
      args[_key92] = arguments[_key92];
    }

    var self = _get(Object.getPrototypeOf(SpliceAt.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(SpliceAt, _RDBOp4);

  return SpliceAt;
})(RDBOp);

SpliceAt.prototype.tt = protoTermType.SPLICE_AT;
SpliceAt.prototype.mt = 'spliceAt';

var DeleteAt = (function (_RDBOp5) {
  function DeleteAt() {
    _classCallCheck(this, DeleteAt);

    for (var _len93 = arguments.length, args = Array(_len93), _key93 = 0; _key93 < _len93; _key93++) {
      args[_key93] = arguments[_key93];
    }

    var self = _get(Object.getPrototypeOf(DeleteAt.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(DeleteAt, _RDBOp5);

  return DeleteAt;
})(RDBOp);

DeleteAt.prototype.tt = protoTermType.DELETE_AT;
DeleteAt.prototype.mt = 'deleteAt';

var ChangeAt = (function (_RDBOp6) {
  function ChangeAt() {
    _classCallCheck(this, ChangeAt);

    for (var _len94 = arguments.length, args = Array(_len94), _key94 = 0; _key94 < _len94; _key94++) {
      args[_key94] = arguments[_key94];
    }

    var self = _get(Object.getPrototypeOf(ChangeAt.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(ChangeAt, _RDBOp6);

  return ChangeAt;
})(RDBOp);

ChangeAt.prototype.tt = protoTermType.CHANGE_AT;
ChangeAt.prototype.mt = 'changeAt';

var HasFields = (function (_RDBOp7) {
  function HasFields() {
    _classCallCheck(this, HasFields);

    for (var _len95 = arguments.length, args = Array(_len95), _key95 = 0; _key95 < _len95; _key95++) {
      args[_key95] = arguments[_key95];
    }

    var self = _get(Object.getPrototypeOf(HasFields.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(HasFields, _RDBOp7);

  return HasFields;
})(RDBOp);

HasFields.prototype.tt = protoTermType.HAS_FIELDS;
HasFields.prototype.mt = 'hasFields';

var WithFields = (function (_RDBOp8) {
  function WithFields() {
    _classCallCheck(this, WithFields);

    for (var _len96 = arguments.length, args = Array(_len96), _key96 = 0; _key96 < _len96; _key96++) {
      args[_key96] = arguments[_key96];
    }

    var self = _get(Object.getPrototypeOf(WithFields.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(WithFields, _RDBOp8);

  return WithFields;
})(RDBOp);

WithFields.prototype.tt = protoTermType.WITH_FIELDS;
WithFields.prototype.mt = 'withFields';

var Keys = (function (_RDBOp9) {
  function Keys() {
    _classCallCheck(this, Keys);

    for (var _len97 = arguments.length, args = Array(_len97), _key97 = 0; _key97 < _len97; _key97++) {
      args[_key97] = arguments[_key97];
    }

    var self = _get(Object.getPrototypeOf(Keys.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Keys, _RDBOp9);

  return Keys;
})(RDBOp);

Keys.prototype.tt = protoTermType.KEYS;
Keys.prototype.mt = 'keys';

//class Changes extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//Changes.prototype.tt = protoTermType.CHANGES;
//Changes.prototype.mt = 'changes';

var Object_ = (function (_RDBOp10) {
  function Object_() {
    _classCallCheck(this, Object_);

    for (var _len98 = arguments.length, args = Array(_len98), _key98 = 0; _key98 < _len98; _key98++) {
      args[_key98] = arguments[_key98];
    }

    var self = _get(Object.getPrototypeOf(Object_.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Object_, _RDBOp10);

  return Object_;
})(RDBOp);

Object_.prototype.tt = protoTermType.OBJECT;
Object_.prototype.mt = 'object';

var Pluck = (function (_RDBOp11) {
  function Pluck() {
    _classCallCheck(this, Pluck);

    for (var _len99 = arguments.length, args = Array(_len99), _key99 = 0; _key99 < _len99; _key99++) {
      args[_key99] = arguments[_key99];
    }

    var self = _get(Object.getPrototypeOf(Pluck.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Pluck, _RDBOp11);

  return Pluck;
})(RDBOp);

Pluck.prototype.tt = protoTermType.PLUCK;
Pluck.prototype.mt = 'pluck';

var OffsetsOf = (function (_RDBOp12) {
  function OffsetsOf() {
    _classCallCheck(this, OffsetsOf);

    for (var _len100 = arguments.length, args = Array(_len100), _key100 = 0; _key100 < _len100; _key100++) {
      args[_key100] = arguments[_key100];
    }

    var self = _get(Object.getPrototypeOf(OffsetsOf.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(OffsetsOf, _RDBOp12);

  return OffsetsOf;
})(RDBOp);

OffsetsOf.prototype.tt = protoTermType.OFFSETS_OF;
OffsetsOf.prototype.mt = 'offsetsOf';

var Without = (function (_RDBOp13) {
  function Without() {
    _classCallCheck(this, Without);

    for (var _len101 = arguments.length, args = Array(_len101), _key101 = 0; _key101 < _len101; _key101++) {
      args[_key101] = arguments[_key101];
    }

    var self = _get(Object.getPrototypeOf(Without.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Without, _RDBOp13);

  return Without;
})(RDBOp);

Without.prototype.tt = protoTermType.WITHOUT;
Without.prototype.mt = 'without';

var Merge = (function (_RDBOp14) {
  function Merge() {
    _classCallCheck(this, Merge);

    for (var _len102 = arguments.length, args = Array(_len102), _key102 = 0; _key102 < _len102; _key102++) {
      args[_key102] = arguments[_key102];
    }

    var self = _get(Object.getPrototypeOf(Merge.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Merge, _RDBOp14);

  return Merge;
})(RDBOp);

Merge.prototype.tt = protoTermType.MERGE;
Merge.prototype.mt = 'merge';

var Between = (function (_RDBOp15) {
  function Between() {
    _classCallCheck(this, Between);

    for (var _len103 = arguments.length, args = Array(_len103), _key103 = 0; _key103 < _len103; _key103++) {
      args[_key103] = arguments[_key103];
    }

    var self = _get(Object.getPrototypeOf(Between.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Between, _RDBOp15);

  return Between;
})(RDBOp);

Between.prototype.tt = protoTermType.BETWEEN;
Between.prototype.mt = 'between';

var Reduce = (function (_RDBOp16) {
  function Reduce() {
    _classCallCheck(this, Reduce);

    for (var _len104 = arguments.length, args = Array(_len104), _key104 = 0; _key104 < _len104; _key104++) {
      args[_key104] = arguments[_key104];
    }

    var self = _get(Object.getPrototypeOf(Reduce.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Reduce, _RDBOp16);

  return Reduce;
})(RDBOp);

Reduce.prototype.tt = protoTermType.REDUCE;
Reduce.prototype.mt = 'reduce';

var Map = (function (_RDBOp17) {
  function Map() {
    _classCallCheck(this, Map);

    for (var _len105 = arguments.length, args = Array(_len105), _key105 = 0; _key105 < _len105; _key105++) {
      args[_key105] = arguments[_key105];
    }

    var self = _get(Object.getPrototypeOf(Map.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Map, _RDBOp17);

  return Map;
})(RDBOp);

Map.prototype.tt = protoTermType.MAP;
Map.prototype.mt = 'map';

var Filter = (function (_RDBOp18) {
  function Filter() {
    _classCallCheck(this, Filter);

    for (var _len106 = arguments.length, args = Array(_len106), _key106 = 0; _key106 < _len106; _key106++) {
      args[_key106] = arguments[_key106];
    }

    var self = _get(Object.getPrototypeOf(Filter.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Filter, _RDBOp18);

  return Filter;
})(RDBOp);

Filter.prototype.tt = protoTermType.FILTER;
Filter.prototype.mt = 'filter';

var ConcatMap = (function (_RDBOp19) {
  function ConcatMap() {
    _classCallCheck(this, ConcatMap);

    for (var _len107 = arguments.length, args = Array(_len107), _key107 = 0; _key107 < _len107; _key107++) {
      args[_key107] = arguments[_key107];
    }

    var self = _get(Object.getPrototypeOf(ConcatMap.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(ConcatMap, _RDBOp19);

  return ConcatMap;
})(RDBOp);

ConcatMap.prototype.tt = protoTermType.CONCAT_MAP;
ConcatMap.prototype.mt = 'concatMap';

var OrderBy = (function (_RDBOp20) {
  function OrderBy() {
    _classCallCheck(this, OrderBy);

    for (var _len108 = arguments.length, args = Array(_len108), _key108 = 0; _key108 < _len108; _key108++) {
      args[_key108] = arguments[_key108];
    }

    var self = _get(Object.getPrototypeOf(OrderBy.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(OrderBy, _RDBOp20);

  return OrderBy;
})(RDBOp);

OrderBy.prototype.tt = protoTermType.ORDER_BY;
OrderBy.prototype.mt = 'orderBy';

var Distinct = (function (_RDBOp21) {
  function Distinct() {
    _classCallCheck(this, Distinct);

    for (var _len109 = arguments.length, args = Array(_len109), _key109 = 0; _key109 < _len109; _key109++) {
      args[_key109] = arguments[_key109];
    }

    var self = _get(Object.getPrototypeOf(Distinct.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Distinct, _RDBOp21);

  return Distinct;
})(RDBOp);

Distinct.prototype.tt = protoTermType.DISTINCT;
Distinct.prototype.mt = 'distinct';

var Count = (function (_RDBOp22) {
  function Count() {
    _classCallCheck(this, Count);

    for (var _len110 = arguments.length, args = Array(_len110), _key110 = 0; _key110 < _len110; _key110++) {
      args[_key110] = arguments[_key110];
    }

    var self = _get(Object.getPrototypeOf(Count.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Count, _RDBOp22);

  return Count;
})(RDBOp);

Count.prototype.tt = protoTermType.COUNT;
Count.prototype.mt = 'count';

var Union = (function (_RDBOp23) {
  function Union() {
    _classCallCheck(this, Union);

    for (var _len111 = arguments.length, args = Array(_len111), _key111 = 0; _key111 < _len111; _key111++) {
      args[_key111] = arguments[_key111];
    }

    var self = _get(Object.getPrototypeOf(Union.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Union, _RDBOp23);

  return Union;
})(RDBOp);

Union.prototype.tt = protoTermType.UNION;
Union.prototype.mt = 'union';

var Nth = (function (_RDBOp24) {
  function Nth() {
    _classCallCheck(this, Nth);

    for (var _len112 = arguments.length, args = Array(_len112), _key112 = 0; _key112 < _len112; _key112++) {
      args[_key112] = arguments[_key112];
    }

    var self = _get(Object.getPrototypeOf(Nth.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Nth, _RDBOp24);

  return Nth;
})(RDBOp);

Nth.prototype.tt = protoTermType.NTH;
Nth.prototype.mt = 'nth';

var ToJsonString = (function (_RDBOp25) {
  function ToJsonString() {
    _classCallCheck(this, ToJsonString);

    for (var _len113 = arguments.length, args = Array(_len113), _key113 = 0; _key113 < _len113; _key113++) {
      args[_key113] = arguments[_key113];
    }

    var self = _get(Object.getPrototypeOf(ToJsonString.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(ToJsonString, _RDBOp25);

  return ToJsonString;
})(RDBOp);

ToJsonString.prototype.tt = protoTermType.TO_JSON_STRING;
ToJsonString.prototype.mt = 'toJsonString';

var Match = (function (_RDBOp26) {
  function Match() {
    _classCallCheck(this, Match);

    for (var _len114 = arguments.length, args = Array(_len114), _key114 = 0; _key114 < _len114; _key114++) {
      args[_key114] = arguments[_key114];
    }

    var self = _get(Object.getPrototypeOf(Match.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Match, _RDBOp26);

  return Match;
})(RDBOp);

Match.prototype.tt = protoTermType.MATCH;
Match.prototype.mt = 'match';

var Split = (function (_RDBOp27) {
  function Split() {
    _classCallCheck(this, Split);

    for (var _len115 = arguments.length, args = Array(_len115), _key115 = 0; _key115 < _len115; _key115++) {
      args[_key115] = arguments[_key115];
    }

    var self = _get(Object.getPrototypeOf(Split.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Split, _RDBOp27);

  return Split;
})(RDBOp);

Split.prototype.tt = protoTermType.SPLIT;
Split.prototype.mt = 'split';

var Upcase = (function (_RDBOp28) {
  function Upcase() {
    _classCallCheck(this, Upcase);

    for (var _len116 = arguments.length, args = Array(_len116), _key116 = 0; _key116 < _len116; _key116++) {
      args[_key116] = arguments[_key116];
    }

    var self = _get(Object.getPrototypeOf(Upcase.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Upcase, _RDBOp28);

  return Upcase;
})(RDBOp);

Upcase.prototype.tt = protoTermType.UPCASE;
Upcase.prototype.mt = 'upcase';

var Downcase = (function (_RDBOp29) {
  function Downcase() {
    _classCallCheck(this, Downcase);

    for (var _len117 = arguments.length, args = Array(_len117), _key117 = 0; _key117 < _len117; _key117++) {
      args[_key117] = arguments[_key117];
    }

    var self = _get(Object.getPrototypeOf(Downcase.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Downcase, _RDBOp29);

  return Downcase;
})(RDBOp);

Downcase.prototype.tt = protoTermType.DOWNCASE;
Downcase.prototype.mt = 'downcase';

var IsEmpty = (function (_RDBOp30) {
  function IsEmpty() {
    _classCallCheck(this, IsEmpty);

    for (var _len118 = arguments.length, args = Array(_len118), _key118 = 0; _key118 < _len118; _key118++) {
      args[_key118] = arguments[_key118];
    }

    var self = _get(Object.getPrototypeOf(IsEmpty.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(IsEmpty, _RDBOp30);

  return IsEmpty;
})(RDBOp);

IsEmpty.prototype.tt = protoTermType.IS_EMPTY;
IsEmpty.prototype.mt = 'isEmpty';

var Group = (function (_RDBOp31) {
  function Group() {
    _classCallCheck(this, Group);

    for (var _len119 = arguments.length, args = Array(_len119), _key119 = 0; _key119 < _len119; _key119++) {
      args[_key119] = arguments[_key119];
    }

    var self = _get(Object.getPrototypeOf(Group.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Group, _RDBOp31);

  return Group;
})(RDBOp);

Group.prototype.tt = protoTermType.GROUP;
Group.prototype.mt = 'group';

var Sum = (function (_RDBOp32) {
  function Sum() {
    _classCallCheck(this, Sum);

    for (var _len120 = arguments.length, args = Array(_len120), _key120 = 0; _key120 < _len120; _key120++) {
      args[_key120] = arguments[_key120];
    }

    var self = _get(Object.getPrototypeOf(Sum.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Sum, _RDBOp32);

  return Sum;
})(RDBOp);

Sum.prototype.tt = protoTermType.SUM;
Sum.prototype.mt = 'sum';

var Avg = (function (_RDBOp33) {
  function Avg() {
    _classCallCheck(this, Avg);

    for (var _len121 = arguments.length, args = Array(_len121), _key121 = 0; _key121 < _len121; _key121++) {
      args[_key121] = arguments[_key121];
    }

    var self = _get(Object.getPrototypeOf(Avg.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Avg, _RDBOp33);

  return Avg;
})(RDBOp);

Avg.prototype.tt = protoTermType.AVG;
Avg.prototype.mt = 'avg';

var Min = (function (_RDBOp34) {
  function Min() {
    _classCallCheck(this, Min);

    for (var _len122 = arguments.length, args = Array(_len122), _key122 = 0; _key122 < _len122; _key122++) {
      args[_key122] = arguments[_key122];
    }

    var self = _get(Object.getPrototypeOf(Min.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Min, _RDBOp34);

  return Min;
})(RDBOp);

Min.prototype.tt = protoTermType.MIN;
Min.prototype.mt = 'min';

var Max = (function (_RDBOp35) {
  function Max() {
    _classCallCheck(this, Max);

    for (var _len123 = arguments.length, args = Array(_len123), _key123 = 0; _key123 < _len123; _key123++) {
      args[_key123] = arguments[_key123];
    }

    var self = _get(Object.getPrototypeOf(Max.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Max, _RDBOp35);

  return Max;
})(RDBOp);

Max.prototype.tt = protoTermType.MAX;
Max.prototype.mt = 'max';

var InnerJoin = (function (_RDBOp36) {
  function InnerJoin() {
    _classCallCheck(this, InnerJoin);

    for (var _len124 = arguments.length, args = Array(_len124), _key124 = 0; _key124 < _len124; _key124++) {
      args[_key124] = arguments[_key124];
    }

    var self = _get(Object.getPrototypeOf(InnerJoin.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(InnerJoin, _RDBOp36);

  return InnerJoin;
})(RDBOp);

InnerJoin.prototype.tt = protoTermType.INNER_JOIN;
InnerJoin.prototype.mt = 'innerJoin';

var OuterJoin = (function (_RDBOp37) {
  function OuterJoin() {
    _classCallCheck(this, OuterJoin);

    for (var _len125 = arguments.length, args = Array(_len125), _key125 = 0; _key125 < _len125; _key125++) {
      args[_key125] = arguments[_key125];
    }

    var self = _get(Object.getPrototypeOf(OuterJoin.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(OuterJoin, _RDBOp37);

  return OuterJoin;
})(RDBOp);

OuterJoin.prototype.tt = protoTermType.OUTER_JOIN;
OuterJoin.prototype.mt = 'outerJoin';

var EqJoin = (function (_RDBOp38) {
  function EqJoin() {
    _classCallCheck(this, EqJoin);

    for (var _len126 = arguments.length, args = Array(_len126), _key126 = 0; _key126 < _len126; _key126++) {
      args[_key126] = arguments[_key126];
    }

    var self = _get(Object.getPrototypeOf(EqJoin.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(EqJoin, _RDBOp38);

  return EqJoin;
})(RDBOp);

EqJoin.prototype.tt = protoTermType.EQ_JOIN;
EqJoin.prototype.mt = 'eqJoin';

var Zip = (function (_RDBOp39) {
  function Zip() {
    _classCallCheck(this, Zip);

    for (var _len127 = arguments.length, args = Array(_len127), _key127 = 0; _key127 < _len127; _key127++) {
      args[_key127] = arguments[_key127];
    }

    var self = _get(Object.getPrototypeOf(Zip.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Zip, _RDBOp39);

  return Zip;
})(RDBOp);

Zip.prototype.tt = protoTermType.ZIP;
Zip.prototype.mt = 'zip';

var Range = (function (_RDBOp40) {
  function Range() {
    _classCallCheck(this, Range);

    for (var _len128 = arguments.length, args = Array(_len128), _key128 = 0; _key128 < _len128; _key128++) {
      args[_key128] = arguments[_key128];
    }

    var self = _get(Object.getPrototypeOf(Range.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Range, _RDBOp40);

  return Range;
})(RDBOp);

Range.prototype.tt = protoTermType.RANGE;
Range.prototype.st = 'range';

var CoerceTo = (function (_RDBOp41) {
  function CoerceTo() {
    _classCallCheck(this, CoerceTo);

    for (var _len129 = arguments.length, args = Array(_len129), _key129 = 0; _key129 < _len129; _key129++) {
      args[_key129] = arguments[_key129];
    }

    var self = _get(Object.getPrototypeOf(CoerceTo.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(CoerceTo, _RDBOp41);

  return CoerceTo;
})(RDBOp);

CoerceTo.prototype.tt = protoTermType.COERCE_TO;
CoerceTo.prototype.mt = 'coerceTo';

var Ungroup = (function (_RDBOp42) {
  function Ungroup() {
    _classCallCheck(this, Ungroup);

    for (var _len130 = arguments.length, args = Array(_len130), _key130 = 0; _key130 < _len130; _key130++) {
      args[_key130] = arguments[_key130];
    }

    var self = _get(Object.getPrototypeOf(Ungroup.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Ungroup, _RDBOp42);

  return Ungroup;
})(RDBOp);

Ungroup.prototype.tt = protoTermType.UNGROUP;
Ungroup.prototype.mt = 'ungroup';

var TypeOf = (function (_RDBOp43) {
  function TypeOf() {
    _classCallCheck(this, TypeOf);

    for (var _len131 = arguments.length, args = Array(_len131), _key131 = 0; _key131 < _len131; _key131++) {
      args[_key131] = arguments[_key131];
    }

    var self = _get(Object.getPrototypeOf(TypeOf.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(TypeOf, _RDBOp43);

  return TypeOf;
})(RDBOp);

TypeOf.prototype.tt = protoTermType.TYPE_OF;
TypeOf.prototype.mt = 'typeOf';

//class Info extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//Info.prototype.tt = protoTermType.INFO;
//Info.prototype.mt = 'info';

var Sample = (function (_RDBOp44) {
  function Sample() {
    _classCallCheck(this, Sample);

    for (var _len132 = arguments.length, args = Array(_len132), _key132 = 0; _key132 < _len132; _key132++) {
      args[_key132] = arguments[_key132];
    }

    var self = _get(Object.getPrototypeOf(Sample.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Sample, _RDBOp44);

  return Sample;
})(RDBOp);

Sample.prototype.tt = protoTermType.SAMPLE;
Sample.prototype.mt = 'sample';

var Update = (function (_RDBOp45) {
  function Update() {
    _classCallCheck(this, Update);

    for (var _len133 = arguments.length, args = Array(_len133), _key133 = 0; _key133 < _len133; _key133++) {
      args[_key133] = arguments[_key133];
    }

    var self = _get(Object.getPrototypeOf(Update.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Update, _RDBOp45);

  return Update;
})(RDBOp);

Update.prototype.tt = protoTermType.UPDATE;
Update.prototype.mt = 'update';

var Delete = (function (_RDBOp46) {
  function Delete() {
    _classCallCheck(this, Delete);

    for (var _len134 = arguments.length, args = Array(_len134), _key134 = 0; _key134 < _len134; _key134++) {
      args[_key134] = arguments[_key134];
    }

    var self = _get(Object.getPrototypeOf(Delete.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Delete, _RDBOp46);

  return Delete;
})(RDBOp);

Delete.prototype.tt = protoTermType.DELETE;
Delete.prototype.mt = 'delete';

var Replace = (function (_RDBOp47) {
  function Replace() {
    _classCallCheck(this, Replace);

    for (var _len135 = arguments.length, args = Array(_len135), _key135 = 0; _key135 < _len135; _key135++) {
      args[_key135] = arguments[_key135];
    }

    var self = _get(Object.getPrototypeOf(Replace.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Replace, _RDBOp47);

  return Replace;
})(RDBOp);

Replace.prototype.tt = protoTermType.REPLACE;
Replace.prototype.mt = 'replace';

var Insert = (function (_RDBOp48) {
  function Insert() {
    _classCallCheck(this, Insert);

    for (var _len136 = arguments.length, args = Array(_len136), _key136 = 0; _key136 < _len136; _key136++) {
      args[_key136] = arguments[_key136];
    }

    var self = _get(Object.getPrototypeOf(Insert.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Insert, _RDBOp48);

  return Insert;
})(RDBOp);

Insert.prototype.tt = protoTermType.INSERT;
Insert.prototype.mt = 'insert';

//class DbCreate extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//DbCreate.prototype.tt = protoTermType.DB_CREATE;
//DbCreate.prototype.st = 'dbCreate';
//
//class DbDrop extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//DbDrop.prototype.tt = protoTermType.DB_DROP;
//DbDrop.prototype.st = 'dbDrop';
//
//class DbList extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//DbList.prototype.tt = protoTermType.DB_LIST;
//DbList.prototype.st = 'dbList';

//class TableCreate extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//TableCreate.prototype.tt = protoTermType.TABLE_CREATE;
//TableCreate.prototype.mt = 'tableCreate';
//
//class TableDrop extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//TableDrop.prototype.tt = protoTermType.TABLE_DROP;
//TableDrop.prototype.mt = 'tableDrop';
//
//class TableList extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//TableList.prototype.tt = protoTermType.TABLE_LIST;
//TableList.prototype.mt = 'tableList';

//class IndexCreate extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//IndexCreate.prototype.tt = protoTermType.INDEX_CREATE;
//IndexCreate.prototype.mt = 'indexCreate';
//
//class IndexDrop extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//IndexDrop.prototype.tt = protoTermType.INDEX_DROP;
//IndexDrop.prototype.mt = 'indexDrop';
//
//class IndexRename extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//IndexRename.prototype.tt = protoTermType.INDEX_RENAME;
//IndexRename.prototype.mt = 'indexRename';
//
//class IndexList extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//IndexList.prototype.tt = protoTermType.INDEX_LIST;
//IndexList.prototype.mt = 'indexList';
//
//class IndexStatus extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//IndexStatus.prototype.tt = protoTermType.INDEX_STATUS;
//IndexStatus.prototype.mt = 'indexStatus';
//
//class IndexWait extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//IndexWait.prototype.tt = protoTermType.INDEX_WAIT;
//IndexWait.prototype.mt = 'indexWait';

//class Config extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//Config.prototype.tt = protoTermType.CONFIG;
//Config.prototype.mt = 'config';
//
//class Status extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//Status.prototype.tt = protoTermType.STATUS;
//Status.prototype.mt = 'status';
//
//class Wait extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//Wait.prototype.tt = protoTermType.WAIT;
//Wait.prototype.mt = 'wait';
//
//class Reconfigure extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//Reconfigure.prototype.tt = protoTermType.RECONFIGURE;
//Reconfigure.prototype.mt = 'reconfigure';
//
//class Rebalance extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//Rebalance.prototype.tt = protoTermType.REBALANCE;
//Rebalance.prototype.mt = 'rebalance';
//
//class Sync extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//Sync.prototype.tt = protoTermType.SYNC;
//Sync.prototype.mt = 'sync';

var Get = (function (_RDBOp49) {
  function Get() {
    _classCallCheck(this, Get);

    for (var _len137 = arguments.length, args = Array(_len137), _key137 = 0; _key137 < _len137; _key137++) {
      args[_key137] = arguments[_key137];
    }

    var self = _get(Object.getPrototypeOf(Get.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Get, _RDBOp49);

  return Get;
})(RDBOp);

Get.prototype.tt = protoTermType.GET;
Get.prototype.mt = 'get';

var GetAll = (function (_RDBOp50) {
  function GetAll() {
    _classCallCheck(this, GetAll);

    for (var _len138 = arguments.length, args = Array(_len138), _key138 = 0; _key138 < _len138; _key138++) {
      args[_key138] = arguments[_key138];
    }

    var self = _get(Object.getPrototypeOf(GetAll.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(GetAll, _RDBOp50);

  return GetAll;
})(RDBOp);

GetAll.prototype.tt = protoTermType.GET_ALL;
GetAll.prototype.mt = 'getAll';

var Eq = (function (_RDBOp51) {
  function Eq() {
    _classCallCheck(this, Eq);

    for (var _len139 = arguments.length, args = Array(_len139), _key139 = 0; _key139 < _len139; _key139++) {
      args[_key139] = arguments[_key139];
    }

    var self = _get(Object.getPrototypeOf(Eq.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Eq, _RDBOp51);

  return Eq;
})(RDBOp);

Eq.prototype.tt = protoTermType.EQ;
Eq.prototype.mt = 'eq';

var Ne = (function (_RDBOp52) {
  function Ne() {
    _classCallCheck(this, Ne);

    for (var _len140 = arguments.length, args = Array(_len140), _key140 = 0; _key140 < _len140; _key140++) {
      args[_key140] = arguments[_key140];
    }

    var self = _get(Object.getPrototypeOf(Ne.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Ne, _RDBOp52);

  return Ne;
})(RDBOp);

Ne.prototype.tt = protoTermType.NE;
Ne.prototype.mt = 'ne';

var Lt = (function (_RDBOp53) {
  function Lt() {
    _classCallCheck(this, Lt);

    for (var _len141 = arguments.length, args = Array(_len141), _key141 = 0; _key141 < _len141; _key141++) {
      args[_key141] = arguments[_key141];
    }

    var self = _get(Object.getPrototypeOf(Lt.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Lt, _RDBOp53);

  return Lt;
})(RDBOp);

Lt.prototype.tt = protoTermType.LT;
Lt.prototype.mt = 'lt';

var Le = (function (_RDBOp54) {
  function Le() {
    _classCallCheck(this, Le);

    for (var _len142 = arguments.length, args = Array(_len142), _key142 = 0; _key142 < _len142; _key142++) {
      args[_key142] = arguments[_key142];
    }

    var self = _get(Object.getPrototypeOf(Le.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Le, _RDBOp54);

  return Le;
})(RDBOp);

Le.prototype.tt = protoTermType.LE;
Le.prototype.mt = 'le';

var Gt = (function (_RDBOp55) {
  function Gt() {
    _classCallCheck(this, Gt);

    for (var _len143 = arguments.length, args = Array(_len143), _key143 = 0; _key143 < _len143; _key143++) {
      args[_key143] = arguments[_key143];
    }

    var self = _get(Object.getPrototypeOf(Gt.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Gt, _RDBOp55);

  return Gt;
})(RDBOp);

Gt.prototype.tt = protoTermType.GT;
Gt.prototype.mt = 'gt';

var Ge = (function (_RDBOp56) {
  function Ge() {
    _classCallCheck(this, Ge);

    for (var _len144 = arguments.length, args = Array(_len144), _key144 = 0; _key144 < _len144; _key144++) {
      args[_key144] = arguments[_key144];
    }

    var self = _get(Object.getPrototypeOf(Ge.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Ge, _RDBOp56);

  return Ge;
})(RDBOp);

Ge.prototype.tt = protoTermType.GE;
Ge.prototype.mt = 'ge';

var Not = (function (_RDBOp57) {
  function Not() {
    _classCallCheck(this, Not);

    for (var _len145 = arguments.length, args = Array(_len145), _key145 = 0; _key145 < _len145; _key145++) {
      args[_key145] = arguments[_key145];
    }

    var self = _get(Object.getPrototypeOf(Not.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Not, _RDBOp57);

  return Not;
})(RDBOp);

Not.prototype.tt = protoTermType.NOT;
Not.prototype.mt = 'not';

var Add = (function (_RDBOp58) {
  function Add() {
    _classCallCheck(this, Add);

    for (var _len146 = arguments.length, args = Array(_len146), _key146 = 0; _key146 < _len146; _key146++) {
      args[_key146] = arguments[_key146];
    }

    var self = _get(Object.getPrototypeOf(Add.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Add, _RDBOp58);

  return Add;
})(RDBOp);

Add.prototype.tt = protoTermType.ADD;
Add.prototype.mt = 'add';

var Sub = (function (_RDBOp59) {
  function Sub() {
    _classCallCheck(this, Sub);

    for (var _len147 = arguments.length, args = Array(_len147), _key147 = 0; _key147 < _len147; _key147++) {
      args[_key147] = arguments[_key147];
    }

    var self = _get(Object.getPrototypeOf(Sub.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Sub, _RDBOp59);

  return Sub;
})(RDBOp);

Sub.prototype.tt = protoTermType.SUB;
Sub.prototype.mt = 'sub';

var Mul = (function (_RDBOp60) {
  function Mul() {
    _classCallCheck(this, Mul);

    for (var _len148 = arguments.length, args = Array(_len148), _key148 = 0; _key148 < _len148; _key148++) {
      args[_key148] = arguments[_key148];
    }

    var self = _get(Object.getPrototypeOf(Mul.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Mul, _RDBOp60);

  return Mul;
})(RDBOp);

Mul.prototype.tt = protoTermType.MUL;
Mul.prototype.mt = 'mul';

var Div = (function (_RDBOp61) {
  function Div() {
    _classCallCheck(this, Div);

    for (var _len149 = arguments.length, args = Array(_len149), _key149 = 0; _key149 < _len149; _key149++) {
      args[_key149] = arguments[_key149];
    }

    var self = _get(Object.getPrototypeOf(Div.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Div, _RDBOp61);

  return Div;
})(RDBOp);

Div.prototype.tt = protoTermType.DIV;
Div.prototype.mt = 'div';

var Mod = (function (_RDBOp62) {
  function Mod() {
    _classCallCheck(this, Mod);

    for (var _len150 = arguments.length, args = Array(_len150), _key150 = 0; _key150 < _len150; _key150++) {
      args[_key150] = arguments[_key150];
    }

    var self = _get(Object.getPrototypeOf(Mod.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Mod, _RDBOp62);

  return Mod;
})(RDBOp);

Mod.prototype.tt = protoTermType.MOD;
Mod.prototype.mt = 'mod';

//class Floor extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//Floor.prototype.tt = protoTermType.FLOOR;
//Floor.prototype.mt = 'floor';
//
//class Ceil extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//Ceil.prototype.tt = protoTermType.CEIL;
//Ceil.prototype.mt = 'ceil';
//
//class Round extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//Round.prototype.tt = protoTermType.ROUND;
//Round.prototype.mt = 'round';

var Append = (function (_RDBOp63) {
  function Append() {
    _classCallCheck(this, Append);

    for (var _len151 = arguments.length, args = Array(_len151), _key151 = 0; _key151 < _len151; _key151++) {
      args[_key151] = arguments[_key151];
    }

    var self = _get(Object.getPrototypeOf(Append.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Append, _RDBOp63);

  return Append;
})(RDBOp);

Append.prototype.tt = protoTermType.APPEND;
Append.prototype.mt = 'append';

var Prepend = (function (_RDBOp64) {
  function Prepend() {
    _classCallCheck(this, Prepend);

    for (var _len152 = arguments.length, args = Array(_len152), _key152 = 0; _key152 < _len152; _key152++) {
      args[_key152] = arguments[_key152];
    }

    var self = _get(Object.getPrototypeOf(Prepend.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Prepend, _RDBOp64);

  return Prepend;
})(RDBOp);

Prepend.prototype.tt = protoTermType.PREPEND;
Prepend.prototype.mt = 'prepend';

var Difference = (function (_RDBOp65) {
  function Difference() {
    _classCallCheck(this, Difference);

    for (var _len153 = arguments.length, args = Array(_len153), _key153 = 0; _key153 < _len153; _key153++) {
      args[_key153] = arguments[_key153];
    }

    var self = _get(Object.getPrototypeOf(Difference.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Difference, _RDBOp65);

  return Difference;
})(RDBOp);

Difference.prototype.tt = protoTermType.DIFFERENCE;
Difference.prototype.mt = 'difference';

var SetInsert = (function (_RDBOp66) {
  function SetInsert() {
    _classCallCheck(this, SetInsert);

    for (var _len154 = arguments.length, args = Array(_len154), _key154 = 0; _key154 < _len154; _key154++) {
      args[_key154] = arguments[_key154];
    }

    var self = _get(Object.getPrototypeOf(SetInsert.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(SetInsert, _RDBOp66);

  return SetInsert;
})(RDBOp);

SetInsert.prototype.tt = protoTermType.SET_INSERT;
SetInsert.prototype.mt = 'setInsert';

var SetUnion = (function (_RDBOp67) {
  function SetUnion() {
    _classCallCheck(this, SetUnion);

    for (var _len155 = arguments.length, args = Array(_len155), _key155 = 0; _key155 < _len155; _key155++) {
      args[_key155] = arguments[_key155];
    }

    var self = _get(Object.getPrototypeOf(SetUnion.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(SetUnion, _RDBOp67);

  return SetUnion;
})(RDBOp);

SetUnion.prototype.tt = protoTermType.SET_UNION;
SetUnion.prototype.mt = 'setUnion';

var SetIntersection = (function (_RDBOp68) {
  function SetIntersection() {
    _classCallCheck(this, SetIntersection);

    for (var _len156 = arguments.length, args = Array(_len156), _key156 = 0; _key156 < _len156; _key156++) {
      args[_key156] = arguments[_key156];
    }

    var self = _get(Object.getPrototypeOf(SetIntersection.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(SetIntersection, _RDBOp68);

  return SetIntersection;
})(RDBOp);

SetIntersection.prototype.tt = protoTermType.SET_INTERSECTION;
SetIntersection.prototype.mt = 'setIntersection';

var SetDifference = (function (_RDBOp69) {
  function SetDifference() {
    _classCallCheck(this, SetDifference);

    for (var _len157 = arguments.length, args = Array(_len157), _key157 = 0; _key157 < _len157; _key157++) {
      args[_key157] = arguments[_key157];
    }

    var self = _get(Object.getPrototypeOf(SetDifference.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(SetDifference, _RDBOp69);

  return SetDifference;
})(RDBOp);

SetDifference.prototype.tt = protoTermType.SET_DIFFERENCE;
SetDifference.prototype.mt = 'setDifference';

var Slice = (function (_RDBOp70) {
  function Slice() {
    _classCallCheck(this, Slice);

    for (var _len158 = arguments.length, args = Array(_len158), _key158 = 0; _key158 < _len158; _key158++) {
      args[_key158] = arguments[_key158];
    }

    var self = _get(Object.getPrototypeOf(Slice.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Slice, _RDBOp70);

  return Slice;
})(RDBOp);

Slice.prototype.tt = protoTermType.SLICE;
Slice.prototype.mt = 'slice';

var Skip = (function (_RDBOp71) {
  function Skip() {
    _classCallCheck(this, Skip);

    for (var _len159 = arguments.length, args = Array(_len159), _key159 = 0; _key159 < _len159; _key159++) {
      args[_key159] = arguments[_key159];
    }

    var self = _get(Object.getPrototypeOf(Skip.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Skip, _RDBOp71);

  return Skip;
})(RDBOp);

Skip.prototype.tt = protoTermType.SKIP;
Skip.prototype.mt = 'skip';

var Limit = (function (_RDBOp72) {
  function Limit() {
    _classCallCheck(this, Limit);

    for (var _len160 = arguments.length, args = Array(_len160), _key160 = 0; _key160 < _len160; _key160++) {
      args[_key160] = arguments[_key160];
    }

    var self = _get(Object.getPrototypeOf(Limit.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Limit, _RDBOp72);

  return Limit;
})(RDBOp);

Limit.prototype.tt = protoTermType.LIMIT;
Limit.prototype.mt = 'limit';

var GetField = (function (_RDBOp73) {
  function GetField() {
    _classCallCheck(this, GetField);

    for (var _len161 = arguments.length, args = Array(_len161), _key161 = 0; _key161 < _len161; _key161++) {
      args[_key161] = arguments[_key161];
    }

    var self = _get(Object.getPrototypeOf(GetField.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(GetField, _RDBOp73);

  return GetField;
})(RDBOp);

GetField.prototype.tt = protoTermType.GET_FIELD;
GetField.prototype.mt = 'getField';

/* istanbul ignore next */

var Db = (function (_RDBOp74) {
  function Db() {
    _classCallCheck(this, Db);

    for (var _len162 = arguments.length, args = Array(_len162), _key162 = 0; _key162 < _len162; _key162++) {
      args[_key162] = arguments[_key162];
    }

    var self = _get(Object.getPrototypeOf(Db.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Db, _RDBOp74);

  return Db;
})(RDBOp);

Db.prototype.tt = protoTermType.DB;
Db.prototype.st = 'db';

var Args = (function (_RDBOp75) {
  function Args() {
    _classCallCheck(this, Args);

    for (var _len163 = arguments.length, args = Array(_len163), _key163 = 0; _key163 < _len163; _key163++) {
      args[_key163] = arguments[_key163];
    }

    var self = _get(Object.getPrototypeOf(Args.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Args, _RDBOp75);

  return Args;
})(RDBOp);

Args.prototype.tt = protoTermType.ARGS;
Args.prototype.st = 'args';

var UserError = (function (_RDBOp76) {
  function UserError() {
    _classCallCheck(this, UserError);

    for (var _len164 = arguments.length, args = Array(_len164), _key164 = 0; _key164 < _len164; _key164++) {
      args[_key164] = arguments[_key164];
    }

    var self = _get(Object.getPrototypeOf(UserError.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(UserError, _RDBOp76);

  return UserError;
})(RDBOp);

UserError.prototype.tt = protoTermType.ERROR;
UserError.prototype.st = 'error';

var Random = (function (_RDBOp77) {
  function Random() {
    _classCallCheck(this, Random);

    for (var _len165 = arguments.length, args = Array(_len165), _key165 = 0; _key165 < _len165; _key165++) {
      args[_key165] = arguments[_key165];
    }

    var self = _get(Object.getPrototypeOf(Random.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Random, _RDBOp77);

  return Random;
})(RDBOp);

Random.prototype.tt = protoTermType.RANDOM;
Random.prototype.st = 'random';

//class JavaScript extends RDBOp {
//  constructor(...args) {
//    let self = super(...args);
//    self.__proto__ = this.__proto__;
//    return self;
//  }
//}
//JavaScript.prototype.tt = protoTermType.JAVASCRIPT;
//JavaScript.prototype.st = 'js';

var Http = (function (_RDBOp78) {
  function Http() {
    _classCallCheck(this, Http);

    for (var _len166 = arguments.length, args = Array(_len166), _key166 = 0; _key166 < _len166; _key166++) {
      args[_key166] = arguments[_key166];
    }

    var self = _get(Object.getPrototypeOf(Http.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Http, _RDBOp78);

  return Http;
})(RDBOp);

Http.prototype.tt = protoTermType.HTTP;
Http.prototype.st = 'http';

var Json = (function (_RDBOp79) {
  function Json() {
    _classCallCheck(this, Json);

    for (var _len167 = arguments.length, args = Array(_len167), _key167 = 0; _key167 < _len167; _key167++) {
      args[_key167] = arguments[_key167];
    }

    var self = _get(Object.getPrototypeOf(Json.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Json, _RDBOp79);

  return Json;
})(RDBOp);

Json.prototype.tt = protoTermType.JSON;
Json.prototype.st = 'json';

var Asc = (function (_RDBOp80) {
  function Asc() {
    _classCallCheck(this, Asc);

    for (var _len168 = arguments.length, args = Array(_len168), _key168 = 0; _key168 < _len168; _key168++) {
      args[_key168] = arguments[_key168];
    }

    var self = _get(Object.getPrototypeOf(Asc.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Asc, _RDBOp80);

  return Asc;
})(RDBOp);

Asc.prototype.tt = protoTermType.ASC;
Asc.prototype.st = 'asc';

var Desc = (function (_RDBOp81) {
  function Desc() {
    _classCallCheck(this, Desc);

    for (var _len169 = arguments.length, args = Array(_len169), _key169 = 0; _key169 < _len169; _key169++) {
      args[_key169] = arguments[_key169];
    }

    var self = _get(Object.getPrototypeOf(Desc.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Desc, _RDBOp81);

  return Desc;
})(RDBOp);

Desc.prototype.tt = protoTermType.DESC;
Desc.prototype.st = 'desc';

var Literal = (function (_RDBOp82) {
  function Literal() {
    _classCallCheck(this, Literal);

    for (var _len170 = arguments.length, args = Array(_len170), _key170 = 0; _key170 < _len170; _key170++) {
      args[_key170] = arguments[_key170];
    }

    var self = _get(Object.getPrototypeOf(Literal.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Literal, _RDBOp82);

  return Literal;
})(RDBOp);

Literal.prototype.tt = protoTermType.LITERAL;
Literal.prototype.st = 'literal';

var ISO8601 = (function (_RDBOp83) {
  function ISO8601() {
    _classCallCheck(this, ISO8601);

    for (var _len171 = arguments.length, args = Array(_len171), _key171 = 0; _key171 < _len171; _key171++) {
      args[_key171] = arguments[_key171];
    }

    var self = _get(Object.getPrototypeOf(ISO8601.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(ISO8601, _RDBOp83);

  return ISO8601;
})(RDBOp);

ISO8601.prototype.tt = protoTermType.ISO8601;
ISO8601.prototype.st = 'ISO8601';

var ToISO8601 = (function (_RDBOp84) {
  function ToISO8601() {
    _classCallCheck(this, ToISO8601);

    for (var _len172 = arguments.length, args = Array(_len172), _key172 = 0; _key172 < _len172; _key172++) {
      args[_key172] = arguments[_key172];
    }

    var self = _get(Object.getPrototypeOf(ToISO8601.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(ToISO8601, _RDBOp84);

  return ToISO8601;
})(RDBOp);

ToISO8601.prototype.tt = protoTermType.TO_ISO8601;
ToISO8601.prototype.mt = 'toISO8601';

var EpochTime = (function (_RDBOp85) {
  function EpochTime() {
    _classCallCheck(this, EpochTime);

    for (var _len173 = arguments.length, args = Array(_len173), _key173 = 0; _key173 < _len173; _key173++) {
      args[_key173] = arguments[_key173];
    }

    var self = _get(Object.getPrototypeOf(EpochTime.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(EpochTime, _RDBOp85);

  return EpochTime;
})(RDBOp);

EpochTime.prototype.tt = protoTermType.EPOCH_TIME;
EpochTime.prototype.st = 'epochTime';

var ToEpochTime = (function (_RDBOp86) {
  function ToEpochTime() {
    _classCallCheck(this, ToEpochTime);

    for (var _len174 = arguments.length, args = Array(_len174), _key174 = 0; _key174 < _len174; _key174++) {
      args[_key174] = arguments[_key174];
    }

    var self = _get(Object.getPrototypeOf(ToEpochTime.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(ToEpochTime, _RDBOp86);

  return ToEpochTime;
})(RDBOp);

ToEpochTime.prototype.tt = protoTermType.TO_EPOCH_TIME;
ToEpochTime.prototype.mt = 'toEpochTime';

var Now = (function (_RDBOp87) {
  function Now() {
    _classCallCheck(this, Now);

    for (var _len175 = arguments.length, args = Array(_len175), _key175 = 0; _key175 < _len175; _key175++) {
      args[_key175] = arguments[_key175];
    }

    var self = _get(Object.getPrototypeOf(Now.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Now, _RDBOp87);

  return Now;
})(RDBOp);

Now.prototype.tt = protoTermType.NOW;
Now.prototype.st = 'now';

var InTimezone = (function (_RDBOp88) {
  function InTimezone() {
    _classCallCheck(this, InTimezone);

    for (var _len176 = arguments.length, args = Array(_len176), _key176 = 0; _key176 < _len176; _key176++) {
      args[_key176] = arguments[_key176];
    }

    var self = _get(Object.getPrototypeOf(InTimezone.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(InTimezone, _RDBOp88);

  return InTimezone;
})(RDBOp);

InTimezone.prototype.tt = protoTermType.IN_TIMEZONE;
InTimezone.prototype.mt = 'inTimezone';

var During = (function (_RDBOp89) {
  function During() {
    _classCallCheck(this, During);

    for (var _len177 = arguments.length, args = Array(_len177), _key177 = 0; _key177 < _len177; _key177++) {
      args[_key177] = arguments[_key177];
    }

    var self = _get(Object.getPrototypeOf(During.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(During, _RDBOp89);

  return During;
})(RDBOp);

During.prototype.tt = protoTermType.DURING;
During.prototype.mt = 'during';

var RQLDate = (function (_RDBOp90) {
  function RQLDate() {
    _classCallCheck(this, RQLDate);

    for (var _len178 = arguments.length, args = Array(_len178), _key178 = 0; _key178 < _len178; _key178++) {
      args[_key178] = arguments[_key178];
    }

    var self = _get(Object.getPrototypeOf(RQLDate.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(RQLDate, _RDBOp90);

  return RQLDate;
})(RDBOp);

RQLDate.prototype.tt = protoTermType.DATE;
RQLDate.prototype.mt = 'date';

var TimeOfDay = (function (_RDBOp91) {
  function TimeOfDay() {
    _classCallCheck(this, TimeOfDay);

    for (var _len179 = arguments.length, args = Array(_len179), _key179 = 0; _key179 < _len179; _key179++) {
      args[_key179] = arguments[_key179];
    }

    var self = _get(Object.getPrototypeOf(TimeOfDay.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(TimeOfDay, _RDBOp91);

  return TimeOfDay;
})(RDBOp);

TimeOfDay.prototype.tt = protoTermType.TIME_OF_DAY;
TimeOfDay.prototype.mt = 'timeOfDay';

var Timezone = (function (_RDBOp92) {
  function Timezone() {
    _classCallCheck(this, Timezone);

    for (var _len180 = arguments.length, args = Array(_len180), _key180 = 0; _key180 < _len180; _key180++) {
      args[_key180] = arguments[_key180];
    }

    var self = _get(Object.getPrototypeOf(Timezone.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Timezone, _RDBOp92);

  return Timezone;
})(RDBOp);

Timezone.prototype.tt = protoTermType.TIMEZONE;
Timezone.prototype.mt = 'timezone';

var Year = (function (_RDBOp93) {
  function Year() {
    _classCallCheck(this, Year);

    for (var _len181 = arguments.length, args = Array(_len181), _key181 = 0; _key181 < _len181; _key181++) {
      args[_key181] = arguments[_key181];
    }

    var self = _get(Object.getPrototypeOf(Year.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Year, _RDBOp93);

  return Year;
})(RDBOp);

Year.prototype.tt = protoTermType.YEAR;
Year.prototype.mt = 'year';

var Month = (function (_RDBOp94) {
  function Month() {
    _classCallCheck(this, Month);

    for (var _len182 = arguments.length, args = Array(_len182), _key182 = 0; _key182 < _len182; _key182++) {
      args[_key182] = arguments[_key182];
    }

    var self = _get(Object.getPrototypeOf(Month.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Month, _RDBOp94);

  return Month;
})(RDBOp);

Month.prototype.tt = protoTermType.MONTH;
Month.prototype.mt = 'month';

var Day = (function (_RDBOp95) {
  function Day() {
    _classCallCheck(this, Day);

    for (var _len183 = arguments.length, args = Array(_len183), _key183 = 0; _key183 < _len183; _key183++) {
      args[_key183] = arguments[_key183];
    }

    var self = _get(Object.getPrototypeOf(Day.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Day, _RDBOp95);

  return Day;
})(RDBOp);

Day.prototype.tt = protoTermType.DAY;
Day.prototype.mt = 'day';

var DayOfWeek = (function (_RDBOp96) {
  function DayOfWeek() {
    _classCallCheck(this, DayOfWeek);

    for (var _len184 = arguments.length, args = Array(_len184), _key184 = 0; _key184 < _len184; _key184++) {
      args[_key184] = arguments[_key184];
    }

    var self = _get(Object.getPrototypeOf(DayOfWeek.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(DayOfWeek, _RDBOp96);

  return DayOfWeek;
})(RDBOp);

DayOfWeek.prototype.tt = protoTermType.DAY_OF_WEEK;
DayOfWeek.prototype.mt = 'dayOfWeek';

var DayOfYear = (function (_RDBOp97) {
  function DayOfYear() {
    _classCallCheck(this, DayOfYear);

    for (var _len185 = arguments.length, args = Array(_len185), _key185 = 0; _key185 < _len185; _key185++) {
      args[_key185] = arguments[_key185];
    }

    var self = _get(Object.getPrototypeOf(DayOfYear.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(DayOfYear, _RDBOp97);

  return DayOfYear;
})(RDBOp);

DayOfYear.prototype.tt = protoTermType.DAY_OF_YEAR;
DayOfYear.prototype.mt = 'dayOfYear';

var Hours = (function (_RDBOp98) {
  function Hours() {
    _classCallCheck(this, Hours);

    for (var _len186 = arguments.length, args = Array(_len186), _key186 = 0; _key186 < _len186; _key186++) {
      args[_key186] = arguments[_key186];
    }

    var self = _get(Object.getPrototypeOf(Hours.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Hours, _RDBOp98);

  return Hours;
})(RDBOp);

Hours.prototype.tt = protoTermType.HOURS;
Hours.prototype.mt = 'hours';

var Minutes = (function (_RDBOp99) {
  function Minutes() {
    _classCallCheck(this, Minutes);

    for (var _len187 = arguments.length, args = Array(_len187), _key187 = 0; _key187 < _len187; _key187++) {
      args[_key187] = arguments[_key187];
    }

    var self = _get(Object.getPrototypeOf(Minutes.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Minutes, _RDBOp99);

  return Minutes;
})(RDBOp);

Minutes.prototype.tt = protoTermType.MINUTES;
Minutes.prototype.mt = 'minutes';

var Seconds = (function (_RDBOp100) {
  function Seconds() {
    _classCallCheck(this, Seconds);

    for (var _len188 = arguments.length, args = Array(_len188), _key188 = 0; _key188 < _len188; _key188++) {
      args[_key188] = arguments[_key188];
    }

    var self = _get(Object.getPrototypeOf(Seconds.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Seconds, _RDBOp100);

  return Seconds;
})(RDBOp);

Seconds.prototype.tt = protoTermType.SECONDS;
Seconds.prototype.mt = 'seconds';

var Time = (function (_RDBOp101) {
  function Time() {
    _classCallCheck(this, Time);

    for (var _len189 = arguments.length, args = Array(_len189), _key189 = 0; _key189 < _len189; _key189++) {
      args[_key189] = arguments[_key189];
    }

    var self = _get(Object.getPrototypeOf(Time.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Time, _RDBOp101);

  return Time;
})(RDBOp);

Time.prototype.tt = protoTermType.TIME;
Time.prototype.st = 'time';

var Geojson = (function (_RDBOp102) {
  function Geojson() {
    _classCallCheck(this, Geojson);

    for (var _len190 = arguments.length, args = Array(_len190), _key190 = 0; _key190 < _len190; _key190++) {
      args[_key190] = arguments[_key190];
    }

    var self = _get(Object.getPrototypeOf(Geojson.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Geojson, _RDBOp102);

  return Geojson;
})(RDBOp);

Geojson.prototype.tt = protoTermType.GEOJSON;
Geojson.prototype.st = 'geojson';

var ToGeojson = (function (_RDBOp103) {
  function ToGeojson() {
    _classCallCheck(this, ToGeojson);

    for (var _len191 = arguments.length, args = Array(_len191), _key191 = 0; _key191 < _len191; _key191++) {
      args[_key191] = arguments[_key191];
    }

    var self = _get(Object.getPrototypeOf(ToGeojson.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(ToGeojson, _RDBOp103);

  return ToGeojson;
})(RDBOp);

ToGeojson.prototype.tt = protoTermType.TO_GEOJSON;
ToGeojson.prototype.mt = 'toGeojson';

var Point = (function (_RDBOp104) {
  function Point() {
    _classCallCheck(this, Point);

    for (var _len192 = arguments.length, args = Array(_len192), _key192 = 0; _key192 < _len192; _key192++) {
      args[_key192] = arguments[_key192];
    }

    var self = _get(Object.getPrototypeOf(Point.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Point, _RDBOp104);

  return Point;
})(RDBOp);

Point.prototype.tt = protoTermType.POINT;
Point.prototype.st = 'point';

var Line = (function (_RDBOp105) {
  function Line() {
    _classCallCheck(this, Line);

    for (var _len193 = arguments.length, args = Array(_len193), _key193 = 0; _key193 < _len193; _key193++) {
      args[_key193] = arguments[_key193];
    }

    var self = _get(Object.getPrototypeOf(Line.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Line, _RDBOp105);

  return Line;
})(RDBOp);

Line.prototype.tt = protoTermType.LINE;
Line.prototype.st = 'line';

var Polygon = (function (_RDBOp106) {
  function Polygon() {
    _classCallCheck(this, Polygon);

    for (var _len194 = arguments.length, args = Array(_len194), _key194 = 0; _key194 < _len194; _key194++) {
      args[_key194] = arguments[_key194];
    }

    var self = _get(Object.getPrototypeOf(Polygon.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Polygon, _RDBOp106);

  return Polygon;
})(RDBOp);

Polygon.prototype.tt = protoTermType.POLYGON;
Polygon.prototype.st = 'polygon';

var Distance = (function (_RDBOp107) {
  function Distance() {
    _classCallCheck(this, Distance);

    for (var _len195 = arguments.length, args = Array(_len195), _key195 = 0; _key195 < _len195; _key195++) {
      args[_key195] = arguments[_key195];
    }

    var self = _get(Object.getPrototypeOf(Distance.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Distance, _RDBOp107);

  return Distance;
})(RDBOp);

Distance.prototype.tt = protoTermType.DISTANCE;
Distance.prototype.mt = 'distance';

var Intersects = (function (_RDBOp108) {
  function Intersects() {
    _classCallCheck(this, Intersects);

    for (var _len196 = arguments.length, args = Array(_len196), _key196 = 0; _key196 < _len196; _key196++) {
      args[_key196] = arguments[_key196];
    }

    var self = _get(Object.getPrototypeOf(Intersects.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Intersects, _RDBOp108);

  return Intersects;
})(RDBOp);

Intersects.prototype.tt = protoTermType.INTERSECTS;
Intersects.prototype.mt = 'intersects';

var Includes = (function (_RDBOp109) {
  function Includes() {
    _classCallCheck(this, Includes);

    for (var _len197 = arguments.length, args = Array(_len197), _key197 = 0; _key197 < _len197; _key197++) {
      args[_key197] = arguments[_key197];
    }

    var self = _get(Object.getPrototypeOf(Includes.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Includes, _RDBOp109);

  return Includes;
})(RDBOp);

Includes.prototype.tt = protoTermType.INCLUDES;
Includes.prototype.mt = 'includes';

var Circle = (function (_RDBOp110) {
  function Circle() {
    _classCallCheck(this, Circle);

    for (var _len198 = arguments.length, args = Array(_len198), _key198 = 0; _key198 < _len198; _key198++) {
      args[_key198] = arguments[_key198];
    }

    var self = _get(Object.getPrototypeOf(Circle.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Circle, _RDBOp110);

  return Circle;
})(RDBOp);

Circle.prototype.tt = protoTermType.CIRCLE;
Circle.prototype.st = 'circle';

var GetIntersecting = (function (_RDBOp111) {
  function GetIntersecting() {
    _classCallCheck(this, GetIntersecting);

    for (var _len199 = arguments.length, args = Array(_len199), _key199 = 0; _key199 < _len199; _key199++) {
      args[_key199] = arguments[_key199];
    }

    var self = _get(Object.getPrototypeOf(GetIntersecting.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(GetIntersecting, _RDBOp111);

  return GetIntersecting;
})(RDBOp);

GetIntersecting.prototype.tt = protoTermType.GET_INTERSECTING;
GetIntersecting.prototype.mt = 'getIntersecting';

var GetNearest = (function (_RDBOp112) {
  function GetNearest() {
    _classCallCheck(this, GetNearest);

    for (var _len200 = arguments.length, args = Array(_len200), _key200 = 0; _key200 < _len200; _key200++) {
      args[_key200] = arguments[_key200];
    }

    var self = _get(Object.getPrototypeOf(GetNearest.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(GetNearest, _RDBOp112);

  return GetNearest;
})(RDBOp);

GetNearest.prototype.tt = protoTermType.GET_NEAREST;
GetNearest.prototype.mt = 'getNearest';

var Fill = (function (_RDBOp113) {
  function Fill() {
    _classCallCheck(this, Fill);

    for (var _len201 = arguments.length, args = Array(_len201), _key201 = 0; _key201 < _len201; _key201++) {
      args[_key201] = arguments[_key201];
    }

    var self = _get(Object.getPrototypeOf(Fill.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Fill, _RDBOp113);

  return Fill;
})(RDBOp);

Fill.prototype.tt = protoTermType.FILL;
Fill.prototype.mt = 'fill';

var PolygonSub = (function (_RDBOp114) {
  function PolygonSub() {
    _classCallCheck(this, PolygonSub);

    for (var _len202 = arguments.length, args = Array(_len202), _key202 = 0; _key202 < _len202; _key202++) {
      args[_key202] = arguments[_key202];
    }

    var self = _get(Object.getPrototypeOf(PolygonSub.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(PolygonSub, _RDBOp114);

  return PolygonSub;
})(RDBOp);

PolygonSub.prototype.tt = protoTermType.POLYGON_SUB;
PolygonSub.prototype.mt = 'polygonSub';

var UUID = (function (_RDBOp115) {
  function UUID() {
    _classCallCheck(this, UUID);

    for (var _len203 = arguments.length, args = Array(_len203), _key203 = 0; _key203 < _len203; _key203++) {
      args[_key203] = arguments[_key203];
    }

    var self = _get(Object.getPrototypeOf(UUID.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(UUID, _RDBOp115);

  return UUID;
})(RDBOp);

UUID.prototype.tt = protoTermType.UUID;
UUID.prototype.st = 'uuid';

var Default = (function (_RDBOp116) {
  function Default() {
    _classCallCheck(this, Default);

    for (var _len204 = arguments.length, args = Array(_len204), _key204 = 0; _key204 < _len204; _key204++) {
      args[_key204] = arguments[_key204];
    }

    var self = _get(Object.getPrototypeOf(Default.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Default, _RDBOp116);

  return Default;
})(RDBOp);

Default.prototype.tt = protoTermType.DEFAULT;
Default.prototype.mt = 'default';

var Branch = (function (_RDBOp117) {
  function Branch() {
    _classCallCheck(this, Branch);

    for (var _len205 = arguments.length, args = Array(_len205), _key205 = 0; _key205 < _len205; _key205++) {
      args[_key205] = arguments[_key205];
    }

    var self = _get(Object.getPrototypeOf(Branch.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Branch, _RDBOp117);

  return Branch;
})(RDBOp);

Branch.prototype.tt = protoTermType.BRANCH;
Branch.prototype.st = 'branch';

var Or = (function (_RDBOp118) {
  function Or() {
    _classCallCheck(this, Or);

    for (var _len206 = arguments.length, args = Array(_len206), _key206 = 0; _key206 < _len206; _key206++) {
      args[_key206] = arguments[_key206];
    }

    var self = _get(Object.getPrototypeOf(Or.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Or, _RDBOp118);

  return Or;
})(RDBOp);

Or.prototype.tt = protoTermType.OR;
Or.prototype.mt = 'or';

var And = (function (_RDBOp119) {
  function And() {
    _classCallCheck(this, And);

    for (var _len207 = arguments.length, args = Array(_len207), _key207 = 0; _key207 < _len207; _key207++) {
      args[_key207] = arguments[_key207];
    }

    var self = _get(Object.getPrototypeOf(And.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(And, _RDBOp119);

  return And;
})(RDBOp);

And.prototype.tt = protoTermType.AND;
And.prototype.mt = 'and';

var ForEach = (function (_RDBOp120) {
  function ForEach() {
    _classCallCheck(this, ForEach);

    for (var _len208 = arguments.length, args = Array(_len208), _key208 = 0; _key208 < _len208; _key208++) {
      args[_key208] = arguments[_key208];
    }

    var self = _get(Object.getPrototypeOf(ForEach.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(ForEach, _RDBOp120);

  return ForEach;
})(RDBOp);

ForEach.prototype.tt = protoTermType.FOR_EACH;
ForEach.prototype.mt = 'forEach';

var MakeArray = (function (_RDBOp121) {
  function MakeArray() {
    _classCallCheck(this, MakeArray);

    for (var _len209 = arguments.length, args = Array(_len209), _key209 = 0; _key209 < _len209; _key209++) {
      args[_key209] = arguments[_key209];
    }

    var self = _get(Object.getPrototypeOf(MakeArray.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(MakeArray, _RDBOp121);

  _createClass(MakeArray, [{
    key: 'compose',
    value: function compose(args) {
      return ['[', intsp(args), ']'];
    }
  }]);

  return MakeArray;
})(RDBOp);

MakeArray.prototype.tt = protoTermType.MAKE_ARRAY;
MakeArray.prototype.st = '[...]';

var MakeObject = (function (_RDBOp122) {
  function MakeObject(obj) {
    var nestingDepth = arguments[1] === undefined ? 20 : arguments[1];

    _classCallCheck(this, MakeObject);

    var self = _get(Object.getPrototypeOf(MakeObject.prototype), 'constructor', this).call(this, {});
    self.__proto__ = this.__proto__;
    self.optargs = {};
    for (var key in obj) {
      /* istanbul ignore if */
      if (!obj.hasOwnProperty(key)) {
        continue;
      }
      /* istanbul ignore if */
      if (typeof obj[key] === 'undefined') {
        throw new err.RqlDriverError('Object field \'' + key + '\' may not be undefined');
      }
      self.optargs[key] = rdb.expr(obj[key], nestingDepth - 1);
    }
    return self;
  }

  _inherits(MakeObject, _RDBOp122);

  _createClass(MakeObject, [{
    key: 'compose',
    value: function compose(args, optargs) {
      /* istanbul ignore next */
      return kved(optargs);
    }
  }, {
    key: 'build',
    value: function build() {
      var res = {};
      for (var key in this.optargs) {
        /* istanbul ignore if */
        if (!this.optargs.hasOwnProperty(key)) {
          continue;
        }
        res[key] = this.optargs[key].build();
      }
      return res;
    }
  }]);

  return MakeObject;
})(RDBOp);

MakeObject.prototype.tt = protoTermType.MAKE_OBJECT;
MakeObject.prototype.st = '{...}';

var Var = (function (_RDBOp123) {
  function Var() {
    _classCallCheck(this, Var);

    for (var _len210 = arguments.length, args = Array(_len210), _key210 = 0; _key210 < _len210; _key210++) {
      args[_key210] = arguments[_key210];
    }

    var self = _get(Object.getPrototypeOf(Var.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Var, _RDBOp123);

  _createClass(Var, [{
    key: 'compose',
    value: function compose(args) {
      return ['var_' + args];
    }
  }]);

  return Var;
})(RDBOp);

Var.prototype.tt = protoTermType.VAR;

var Binary = (function (_RDBOp124) {
  function Binary(data) {
    _classCallCheck(this, Binary);

    var self = undefined;
    if (data instanceof TermBase) {
      self = _get(Object.getPrototypeOf(Binary.prototype), 'constructor', this).call(this, {}, data);
    } else if (data instanceof Buffer) {
      self = _get(Object.getPrototypeOf(Binary.prototype), 'constructor', this).call(this);
      self.base64_data = data.toString('base64');
    } else {
      throw new TypeError('Parameter to `r.binary` must be a Buffer object or RQL query.');
    }
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Binary, _RDBOp124);

  _createClass(Binary, [{
    key: 'compose',
    value: function compose() {
      if (this.args.length == 0) {
        return 'r.binary(<data>)';
      } else {
        return _get(Object.getPrototypeOf(Binary.prototype), 'compose', this).call(this);
      }
    }
  }, {
    key: 'build',
    value: function build() {
      if (this.args.length == 0) {
        return { '$reql_type$': 'BINARY', 'data': this.base64_data };
      } else {
        return _get(Object.getPrototypeOf(Binary.prototype), 'build', this).call(this);
      }
    }
  }]);

  return Binary;
})(RDBOp);

Binary.prototype.tt = protoTermType.BINARY;
Binary.prototype.st = 'binary';

var ImplicitVar = (function (_RDBOp125) {
  function ImplicitVar() {
    _classCallCheck(this, ImplicitVar);

    for (var _len211 = arguments.length, args = Array(_len211), _key211 = 0; _key211 < _len211; _key211++) {
      args[_key211] = arguments[_key211];
    }

    var self = _get(Object.getPrototypeOf(ImplicitVar.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(ImplicitVar, _RDBOp125);

  _createClass(ImplicitVar, [{
    key: 'compose',
    value: function compose() {
      return ['r.row'];
    }
  }]);

  return ImplicitVar;
})(RDBOp);

ImplicitVar.prototype.tt = protoTermType.IMPLICIT_VAR;

var Table = (function (_RDBOp126) {
  function Table() {
    _classCallCheck(this, Table);

    for (var _len212 = arguments.length, args = Array(_len212), _key212 = 0; _key212 < _len212; _key212++) {
      args[_key212] = arguments[_key212];
    }

    var self = _get(Object.getPrototypeOf(Table.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Table, _RDBOp126);

  _createClass(Table, [{
    key: 'compose',
    value: function compose(args, optargs) {
      if (this.args[0] instanceof Db) {
        return [args[0], '.table(', intspallargs(args.slice(1), optargs), ')'];
      } else {
        return ['r.table(', intspallargs(args, optargs), ')'];
      }
    }
  }]);

  return Table;
})(RDBOp);

Table.prototype.tt = protoTermType.TABLE;
Table.prototype.st = 'table';

var Bracket = (function (_RDBOp127) {
  function Bracket() {
    _classCallCheck(this, Bracket);

    for (var _len213 = arguments.length, args = Array(_len213), _key213 = 0; _key213 < _len213; _key213++) {
      args[_key213] = arguments[_key213];
    }

    var self = _get(Object.getPrototypeOf(Bracket.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Bracket, _RDBOp127);

  _createClass(Bracket, [{
    key: 'compose',
    value: function compose(args) {
      return [args[0], '(', args[1], ')'];
    }
  }]);

  return Bracket;
})(RDBOp);

Bracket.prototype.tt = protoTermType.BRACKET;
Bracket.prototype.st = '(...)'; // This is only used by the `undefined` argument checker

var FunCall = (function (_RDBOp128) {
  function FunCall() {
    _classCallCheck(this, FunCall);

    for (var _len214 = arguments.length, args = Array(_len214), _key214 = 0; _key214 < _len214; _key214++) {
      args[_key214] = arguments[_key214];
    }

    var self = _get(Object.getPrototypeOf(FunCall.prototype), 'constructor', this).apply(this, args);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(FunCall, _RDBOp128);

  _createClass(FunCall, [{
    key: 'compose',
    value: function compose(args) {
      if (args.length > 2) {
        return ['r.do(', intsp(args.slice(1)), ', ', args[0], ')'];
      } else {
        if (shouldWrap(this.args[1])) {
          args[1] = ['r(', args[1], ')'];
        }
        return [args[1], '.do(', args[0], ')'];
      }
    }
  }]);

  return FunCall;
})(RDBOp);

FunCall.prototype.tt = protoTermType.FUNCALL;
FunCall.prototype.st = 'do'; // This is only used by the `undefined` argument checker

var Func = (function (_RDBOp129) {
  function Func(optargs, fn) {
    _classCallCheck(this, Func);

    var args = [];
    var argNums = [];
    var i = 0;
    while (i < fn.length) {
      argNums.push(Func.nextVarId);
      args.push(new Var({}, Func.nextVarId));
      Func.nextVarId++;
      i++;
    }

    var body = fn.apply(undefined, args);
    if (body === void 0) {
      throw new err.RqlDriverError('Anonymous function returned `undefined`. Did you forget a `return`?');
    }
    var argsArr = new (_bind.apply(MakeArray, [null].concat([{}], argNums)))();
    var self = _get(Object.getPrototypeOf(Func.prototype), 'constructor', this).call(this, optargs, argsArr, body);
    self.__proto__ = this.__proto__;
    return self;
  }

  _inherits(Func, _RDBOp129);

  _createClass(Func, [{
    key: 'compose',
    value: function compose(args) {
      if (hasImplicit(args[1]) === true) {
        return [args[1]];
      } else {
        var varStr = '';
        args[0][1].forEach(function (arg, i) {
          if (i % 2 === 0) {
            varStr += Var.prototype.compose(arg);
          } else {
            varStr += arg;
          }
        });
        return ['function(', varStr, ') { return ', args[1], '; }'];
      }
    }
  }]);

  return Func;
})(RDBOp);

Func.prototype.tt = protoTermType.FUNC;
Func.nextVarId = 0;

rdb.expr = varar(1, 2, function (val) {
  var nestingDepth = arguments[1] === undefined ? 20 : arguments[1];

  if (val === void 0) {
    throw new err.RqlDriverError('Cannot wrap undefined with r.expr().');
  }

  if (nestingDepth <= 0) {
    throw new err.RqlDriverError('Nesting depth limit exceeded');
  } else if (val instanceof TermBase) {
    return val;
  } else if (typeof val === 'function') {
    return new Func({}, val);
  } else if (val instanceof Date) {
    return new ISO8601({}, val.toISOString());
  } else if (val instanceof Buffer) {
    return new Binary(val);
  } else if (Array.isArray(val)) {
    val = val.map(function (v) {
      return rdb.expr(v, nestingDepth - 1);
    });
    return new (_bind.apply(MakeArray, [null].concat([{}], _toConsumableArray(val))))();
  } else if (typeof val === 'number') {
    return new DatumTerm(val);
  } else if (Object.prototype.toString.call(val) === '[object Object]') {
    return new MakeObject(val, nestingDepth);
  } else {
    return new DatumTerm(val);
  }
});

//rdb.js = aropt(function (jssrc, opts) {
//  return new JavaScript(opts, jssrc);
//});

rdb.http = aropt(function (url, opts) {
  return new Http(opts, url);
});

rdb.json = function () {
  for (var _len215 = arguments.length, args = Array(_len215), _key215 = 0; _key215 < _len215; _key215++) {
    args[_key215] = arguments[_key215];
  }

  return new (_bind.apply(Json, [null].concat([{}], args)))();
};

rdb.error = function () {
  for (var _len216 = arguments.length, args = Array(_len216), _key216 = 0; _key216 < _len216; _key216++) {
    args[_key216] = arguments[_key216];
  }

  return new (_bind.apply(UserError, [null].concat([{}], args)))();
};

rdb.random = function () {
  // Default if no opts dict provided
  var opts = {};

  for (var _len217 = arguments.length, limitsAndOpts = Array(_len217), _key217 = 0; _key217 < _len217; _key217++) {
    limitsAndOpts[_key217] = arguments[_key217];
  }

  var limits = limitsAndOpts;

  // Look for opts dict
  var perhapsOptDict = limitsAndOpts[limitsAndOpts.length - 1];
  if (perhapsOptDict && Object.prototype.toString.call(perhapsOptDict) === '[object Object]' && !(perhapsOptDict instanceof TermBase)) {
    opts = perhapsOptDict;
    limits = limitsAndOpts.slice(0, limitsAndOpts.length - 1);
  }
  return new (_bind.apply(Random, [null].concat([opts], _toConsumableArray(limits))))();
};

rdb.binary = ar(function (data) {
  return new Binary(data);
});

rdb.row = new ImplicitVar({});

rdb.table = aropt(function (tblName, opts) {
  return new Table(opts, tblName);
});

rdb.db = function () {
  for (var _len218 = arguments.length, args = Array(_len218), _key218 = 0; _key218 < _len218; _key218++) {
    args[_key218] = arguments[_key218];
  }

  return new (_bind.apply(Db, [null].concat([{}], args)))();
};
//
//rdb.dbCreate = function (...args) {
//  return new DbCreate({}, ...args);
//};
//
//rdb.dbDrop = function (...args) {
//  return new DbDrop({}, ...args);
//};
//
//rdb.dbList = function (...args) {
//  return DbList({}, ...args);
//};
//
//rdb.tableCreate = function (tblName, opts) {
//  return new TableCreate(opts, tblName);
//};
//
//rdb.tableDrop = function (...args) {
//  return new TableDrop({}, ...args);
//};
//
//rdb.tableList = function (...args) {
//  return new TableList({}, ...args);
//};
//
//rdb.wait = aropt(function (opts) {
//  return new Wait(opts);
//});
//
//rdb.reconfigure = function (opts) {
//  return new Reconfigure(opts);
//};
//
//rdb.rebalance = function () {
//  return new Rebalance({});
//};

rdb['do'] = varar(1, null, function () {
  for (var _len219 = arguments.length, args = Array(_len219), _key219 = 0; _key219 < _len219; _key219++) {
    args[_key219] = arguments[_key219];
  }

  return new (_bind.apply(FunCall, [null].concat([{}, funcWrap(args.slice(-1)[0])], _toConsumableArray(args.slice(0, -1)))))();
});

rdb.branch = function () {
  for (var _len220 = arguments.length, args = Array(_len220), _key220 = 0; _key220 < _len220; _key220++) {
    args[_key220] = arguments[_key220];
  }

  return new (_bind.apply(Branch, [null].concat([{}], args)))();
};
rdb.eq = function () {
  for (var _len221 = arguments.length, args = Array(_len221), _key221 = 0; _key221 < _len221; _key221++) {
    args[_key221] = arguments[_key221];
  }

  return new (_bind.apply(Eq, [null].concat([{}], args)))();
};
rdb.ne = function () {
  for (var _len222 = arguments.length, args = Array(_len222), _key222 = 0; _key222 < _len222; _key222++) {
    args[_key222] = arguments[_key222];
  }

  return new (_bind.apply(Ne, [null].concat([{}], args)))();
};
rdb.lt = function () {
  for (var _len223 = arguments.length, args = Array(_len223), _key223 = 0; _key223 < _len223; _key223++) {
    args[_key223] = arguments[_key223];
  }

  return new (_bind.apply(Lt, [null].concat([{}], args)))();
};
rdb.le = function () {
  for (var _len224 = arguments.length, args = Array(_len224), _key224 = 0; _key224 < _len224; _key224++) {
    args[_key224] = arguments[_key224];
  }

  return new (_bind.apply(Le, [null].concat([{}], args)))();
};
rdb.gt = function () {
  for (var _len225 = arguments.length, args = Array(_len225), _key225 = 0; _key225 < _len225; _key225++) {
    args[_key225] = arguments[_key225];
  }

  return new (_bind.apply(Gt, [null].concat([{}], args)))();
};
rdb.ge = function () {
  for (var _len226 = arguments.length, args = Array(_len226), _key226 = 0; _key226 < _len226; _key226++) {
    args[_key226] = arguments[_key226];
  }

  return new (_bind.apply(Ge, [null].concat([{}], args)))();
};
rdb.or = function () {
  for (var _len227 = arguments.length, args = Array(_len227), _key227 = 0; _key227 < _len227; _key227++) {
    args[_key227] = arguments[_key227];
  }

  return new (_bind.apply(Or, [null].concat([{}], args)))();
};
rdb.and = function () {
  for (var _len228 = arguments.length, args = Array(_len228), _key228 = 0; _key228 < _len228; _key228++) {
    args[_key228] = arguments[_key228];
  }

  return new (_bind.apply(And, [null].concat([{}], args)))();
};
rdb.not = function () {
  for (var _len229 = arguments.length, args = Array(_len229), _key229 = 0; _key229 < _len229; _key229++) {
    args[_key229] = arguments[_key229];
  }

  return new (_bind.apply(Not, [null].concat([{}], args)))();
};
rdb.add = function () {
  for (var _len230 = arguments.length, args = Array(_len230), _key230 = 0; _key230 < _len230; _key230++) {
    args[_key230] = arguments[_key230];
  }

  return new (_bind.apply(Add, [null].concat([{}], args)))();
};
rdb.sub = function () {
  for (var _len231 = arguments.length, args = Array(_len231), _key231 = 0; _key231 < _len231; _key231++) {
    args[_key231] = arguments[_key231];
  }

  return new (_bind.apply(Sub, [null].concat([{}], args)))();
};
rdb.div = function () {
  for (var _len232 = arguments.length, args = Array(_len232), _key232 = 0; _key232 < _len232; _key232++) {
    args[_key232] = arguments[_key232];
  }

  return new (_bind.apply(Div, [null].concat([{}], args)))();
};
rdb.mul = function () {
  for (var _len233 = arguments.length, args = Array(_len233), _key233 = 0; _key233 < _len233; _key233++) {
    args[_key233] = arguments[_key233];
  }

  return new (_bind.apply(Mul, [null].concat([{}], args)))();
};
rdb.mod = function () {
  for (var _len234 = arguments.length, args = Array(_len234), _key234 = 0; _key234 < _len234; _key234++) {
    args[_key234] = arguments[_key234];
  }

  return new (_bind.apply(Mod, [null].concat([{}], args)))();
};
//rdb.floor = function (...args) { return new Floor ( {}, ...args ); };
//rdb.ceil = function (...args) { return new Ceil ( {}, ...args ); };
//rdb.round = function (...args) { return new Round ( {}, ...args ); };
rdb.typeOf = function () {
  for (var _len235 = arguments.length, args = Array(_len235), _key235 = 0; _key235 < _len235; _key235++) {
    args[_key235] = arguments[_key235];
  }

  return new (_bind.apply(TypeOf, [null].concat([{}], args)))();
};
//rdb.info = function (...args) { return new Info ( {}, ...args ); };
rdb.literal = function () {
  for (var _len236 = arguments.length, args = Array(_len236), _key236 = 0; _key236 < _len236; _key236++) {
    args[_key236] = arguments[_key236];
  }

  return new (_bind.apply(Literal, [null].concat([{}], args)))();
};
rdb.map = varar(1, null, function () {
  for (var _len237 = arguments.length, args = Array(_len237), _key237 = 0; _key237 < _len237; _key237++) {
    args[_key237] = arguments[_key237];
  }

  var funcArg = args.pop();
  return new (_bind.apply(Map, [null].concat([{}], args, [funcWrap(funcArg)])))();
});

rdb.asc = function () {
  for (var _len238 = arguments.length, args = Array(_len238), _key238 = 0; _key238 < _len238; _key238++) {
    args[_key238] = arguments[_key238];
  }

  return new (_bind.apply(Asc, [null].concat([{}], _toConsumableArray(args.map(funcWrap)))))();
};

rdb.desc = function () {
  for (var _len239 = arguments.length, args = Array(_len239), _key239 = 0; _key239 < _len239; _key239++) {
    args[_key239] = arguments[_key239];
  }

  return new (_bind.apply(Desc, [null].concat([{}], _toConsumableArray(args.map(funcWrap)))))();
};

rdb.ISO8601 = aropt(function (str, opts) {
  return new ISO8601(opts, str);
});

rdb.epochTime = function () {
  for (var _len240 = arguments.length, args = Array(_len240), _key240 = 0; _key240 < _len240; _key240++) {
    args[_key240] = arguments[_key240];
  }

  return new (_bind.apply(EpochTime, [null].concat([{}], args)))();
};

rdb.now = function () {
  for (var _len241 = arguments.length, args = Array(_len241), _key241 = 0; _key241 < _len241; _key241++) {
    args[_key241] = arguments[_key241];
  }

  return new (_bind.apply(Now, [null].concat([{}], args)))();
};

rdb.time = function () {
  for (var _len242 = arguments.length, args = Array(_len242), _key242 = 0; _key242 < _len242; _key242++) {
    args[_key242] = arguments[_key242];
  }

  return new (_bind.apply(Time, [null].concat([{}], args)))();
};

rdb.monday = new ((function () {
  var _Class = (function (_RDBConstant) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len243 = arguments.length, args = Array(_len243), _key243 = 0; _key243 < _len243; _key243++) {
        args[_key243] = arguments[_key243];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.MONDAY;
  _Class.prototype.st = 'monday';
  return _Class;
})())();
rdb.tuesday = new ((function () {
  var _Class = (function (_RDBConstant2) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len244 = arguments.length, args = Array(_len244), _key244 = 0; _key244 < _len244; _key244++) {
        args[_key244] = arguments[_key244];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant2);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.TUESDAY;
  _Class.prototype.st = 'tuesday';
  return _Class;
})())();
rdb.wednesday = new ((function () {
  var _Class = (function (_RDBConstant3) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len245 = arguments.length, args = Array(_len245), _key245 = 0; _key245 < _len245; _key245++) {
        args[_key245] = arguments[_key245];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant3);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.WEDNESDAY;
  _Class.prototype.st = 'wednesday';
  return _Class;
})())();
rdb.thursday = new ((function () {
  var _Class = (function (_RDBConstant4) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len246 = arguments.length, args = Array(_len246), _key246 = 0; _key246 < _len246; _key246++) {
        args[_key246] = arguments[_key246];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant4);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.THURSDAY;
  _Class.prototype.st = 'thursday';
  return _Class;
})())();
rdb.friday = new ((function () {
  var _Class = (function (_RDBConstant5) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len247 = arguments.length, args = Array(_len247), _key247 = 0; _key247 < _len247; _key247++) {
        args[_key247] = arguments[_key247];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant5);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.FRIDAY;
  _Class.prototype.st = 'friday';
  return _Class;
})())();
rdb.saturday = new ((function () {
  var _Class = (function (_RDBConstant6) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len248 = arguments.length, args = Array(_len248), _key248 = 0; _key248 < _len248; _key248++) {
        args[_key248] = arguments[_key248];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant6);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.SATURDAY;
  _Class.prototype.st = 'saturday';
  return _Class;
})())();
rdb.sunday = new ((function () {
  var _Class = (function (_RDBConstant7) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len249 = arguments.length, args = Array(_len249), _key249 = 0; _key249 < _len249; _key249++) {
        args[_key249] = arguments[_key249];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant7);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.SUNDAY;
  _Class.prototype.st = 'sunday';
  return _Class;
})())();
rdb.january = new ((function () {
  var _Class = (function (_RDBConstant8) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len250 = arguments.length, args = Array(_len250), _key250 = 0; _key250 < _len250; _key250++) {
        args[_key250] = arguments[_key250];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant8);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.JANUARY;
  _Class.prototype.st = 'january';
  return _Class;
})())();
rdb.february = new ((function () {
  var _Class = (function (_RDBConstant9) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len251 = arguments.length, args = Array(_len251), _key251 = 0; _key251 < _len251; _key251++) {
        args[_key251] = arguments[_key251];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant9);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.FEBRUARY;
  _Class.prototype.st = 'february';
  return _Class;
})())();
rdb.march = new ((function () {
  var _Class = (function (_RDBConstant10) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len252 = arguments.length, args = Array(_len252), _key252 = 0; _key252 < _len252; _key252++) {
        args[_key252] = arguments[_key252];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant10);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.MARCH;
  _Class.prototype.st = 'march';
  return _Class;
})())();
rdb.april = new ((function () {
  var _Class = (function (_RDBConstant11) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len253 = arguments.length, args = Array(_len253), _key253 = 0; _key253 < _len253; _key253++) {
        args[_key253] = arguments[_key253];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant11);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.APRIL;
  _Class.prototype.st = 'april';
  return _Class;
})())();
rdb.may = new ((function () {
  var _Class = (function (_RDBConstant12) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len254 = arguments.length, args = Array(_len254), _key254 = 0; _key254 < _len254; _key254++) {
        args[_key254] = arguments[_key254];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant12);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.MAY;
  _Class.prototype.st = 'may';
  return _Class;
})())();
rdb.june = new ((function () {
  var _Class = (function (_RDBConstant13) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len255 = arguments.length, args = Array(_len255), _key255 = 0; _key255 < _len255; _key255++) {
        args[_key255] = arguments[_key255];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant13);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.JUNE;
  _Class.prototype.st = 'june';
  return _Class;
})())();
rdb.july = new ((function () {
  var _Class = (function (_RDBConstant14) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len256 = arguments.length, args = Array(_len256), _key256 = 0; _key256 < _len256; _key256++) {
        args[_key256] = arguments[_key256];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant14);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.JULY;
  _Class.prototype.st = 'july';
  return _Class;
})())();
rdb.august = new ((function () {
  var _Class = (function (_RDBConstant15) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len257 = arguments.length, args = Array(_len257), _key257 = 0; _key257 < _len257; _key257++) {
        args[_key257] = arguments[_key257];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant15);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.AUGUST;
  _Class.prototype.st = 'august';
  return _Class;
})())();
rdb.september = new ((function () {
  var _Class = (function (_RDBConstant16) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len258 = arguments.length, args = Array(_len258), _key258 = 0; _key258 < _len258; _key258++) {
        args[_key258] = arguments[_key258];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant16);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.SEPTEMBER;
  _Class.prototype.st = 'september';
  return _Class;
})())();
rdb.october = new ((function () {
  var _Class = (function (_RDBConstant17) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len259 = arguments.length, args = Array(_len259), _key259 = 0; _key259 < _len259; _key259++) {
        args[_key259] = arguments[_key259];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant17);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.OCTOBER;
  _Class.prototype.st = 'october';
  return _Class;
})())();
rdb.november = new ((function () {
  var _Class = (function (_RDBConstant18) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len260 = arguments.length, args = Array(_len260), _key260 = 0; _key260 < _len260; _key260++) {
        args[_key260] = arguments[_key260];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant18);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.NOVEMBER;
  _Class.prototype.st = 'november';
  return _Class;
})())();
rdb.december = new ((function () {
  var _Class = (function (_RDBConstant19) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len261 = arguments.length, args = Array(_len261), _key261 = 0; _key261 < _len261; _key261++) {
        args[_key261] = arguments[_key261];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant19);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.DECEMBER;
  _Class.prototype.st = 'december';
  return _Class;
})())();
rdb.minval = new ((function () {
  var _Class = (function (_RDBConstant20) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len262 = arguments.length, args = Array(_len262), _key262 = 0; _key262 < _len262; _key262++) {
        args[_key262] = arguments[_key262];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant20);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.MINVAL;
  _Class.prototype.st = 'minval';
  return _Class;
})())();
rdb.maxval = new ((function () {
  var _Class = (function (_RDBConstant21) {
    function _Class() {
      _classCallCheck(this, _Class);

      for (var _len263 = arguments.length, args = Array(_len263), _key263 = 0; _key263 < _len263; _key263++) {
        args[_key263] = arguments[_key263];
      }

      var self = _get(Object.getPrototypeOf(_Class.prototype), 'constructor', this).apply(this, args);
      self.__proto__ = this.__proto__;
      return self;
    }

    _inherits(_Class, _RDBConstant21);

    return _Class;
  })(RDBConstant);

  ;
  _Class.prototype.tt = protoTermType.MAXVAL;
  _Class.prototype.st = 'maxval';
  return _Class;
})())();

rdb.object = function () {
  for (var _len264 = arguments.length, args = Array(_len264), _key264 = 0; _key264 < _len264; _key264++) {
    args[_key264] = arguments[_key264];
  }

  return new (_bind.apply(Object_, [null].concat([{}], args)))();
};

rdb.args = function () {
  for (var _len265 = arguments.length, args = Array(_len265), _key265 = 0; _key265 < _len265; _key265++) {
    args[_key265] = arguments[_key265];
  }

  return new (_bind.apply(Args, [null].concat([{}], args)))();
};

rdb.geojson = function () {
  for (var _len266 = arguments.length, args = Array(_len266), _key266 = 0; _key266 < _len266; _key266++) {
    args[_key266] = arguments[_key266];
  }

  return new (_bind.apply(Geojson, [null].concat([{}], args)))();
};
rdb.point = function () {
  for (var _len267 = arguments.length, args = Array(_len267), _key267 = 0; _key267 < _len267; _key267++) {
    args[_key267] = arguments[_key267];
  }

  return new (_bind.apply(Point, [null].concat([{}], args)))();
};
rdb.line = function () {
  for (var _len268 = arguments.length, args = Array(_len268), _key268 = 0; _key268 < _len268; _key268++) {
    args[_key268] = arguments[_key268];
  }

  return new (_bind.apply(Line, [null].concat([{}], args)))();
};
rdb.polygon = function () {
  for (var _len269 = arguments.length, args = Array(_len269), _key269 = 0; _key269 < _len269; _key269++) {
    args[_key269] = arguments[_key269];
  }

  return new (_bind.apply(Polygon, [null].concat([{}], args)))();
};
rdb.intersects = function () {
  for (var _len270 = arguments.length, args = Array(_len270), _key270 = 0; _key270 < _len270; _key270++) {
    args[_key270] = arguments[_key270];
  }

  return new (_bind.apply(Intersects, [null].concat([{}], args)))();
};
rdb.distance = aropt(function (g1, g2, opts) {
  return new Distance(opts, g1, g2);
});
rdb.circle = aropt(function (cen, rad, opts) {
  return new Circle(opts, cen, rad);
});

rdb.uuid = function () {
  for (var _len271 = arguments.length, args = Array(_len271), _key271 = 0; _key271 < _len271; _key271++) {
    args[_key271] = arguments[_key271];
  }

  return new (_bind.apply(UUID, [null].concat([{}], args)))();
};

rdb.range = function () {
  for (var _len272 = arguments.length, args = Array(_len272), _key272 = 0; _key272 < _len272; _key272++) {
    args[_key272] = arguments[_key272];
  }

  return new (_bind.apply(Range, [null].concat([{}], args)))();
};

exports['default'] = rdb;
module.exports = exports['default'];
//# sourceMappingURL=ast.js.map